<?php
// DEFINING MODULE STRUCTURE AND FIELDS


class fr_faq_search_divi_divi_module extends ET_Builder_Module {

	public $slug       = 'fr_faq_search_divi';
	public $vb_support = 'on';
    public $ml_key     = 'fr_ml';
    
    
	protected $module_credits = array(
        'module_uri' => 'https://lcweb.it/faq-revolution-wordpress-plugin',
        'author'     => 'LCweb',
        'author_uri' => 'https://lcweb.it/',
	);

    
    public function get_advanced_fields_config() {
        return unserialize(LC_DIVI_DEF_OPTS_OVERRIDE);
	}

    
	public function init() {
		$this->name               = 'FAQ Revolution';
		$this->icon_path          = $GLOBALS['fr_divi_icon_path'];
		$this->main_css_element   = '%%order_class%%';	
        
        $this->settings_modal_toggles  = array(
			'general'  => array(
				'toggles' => array(
					'main' => esc_html__('Main Options', $this->ml_key),
				),
			),
		);
	}
 
    
	public function get_fields() {
        $opts = array('unset' => '('. __('none', $this->ml_key) .')') + fr_sub_subsubjs_for_builders();
        
        $fields = array(
            'subj_n_child' => array(
                'toggle_slug'     => 'main',
				'label'           => esc_html__('Predefined subject', $this->ml_key),
				'type'            => 'select',
                'default'         => current(array_keys($opts)),
				'default_on_front'=> current(array_keys($opts)),
				'options'         => $opts,
				//'description'     => esc_html__( 'Choose whether your linklink opens in a new window or not', 'dicm-divi-custom-modules' ),
			),
            'excl_subj' => array(
                'toggle_slug'     => 'main',
				'label'           => esc_html__('Excluded subjects', $this->ml_key),
				'type'            => 'categories',
                'renderer_options' => array(
                    'use_terms'    => true,
                    'term_name'    => 'fr_faq_subjs',
                ),
                'default'         => false,
				'default_on_front'=> false,
				//'description'     => esc_html__( 'Choose whether your linklink opens in a new window or not', 'dicm-divi-custom-modules' ),
			),
            'req_src' => array(
                'toggle_slug'     => 'main',
				'label'           => esc_html__('Show FAQs only filling searchbar?', $this->ml_key),
				'type'            => 'yes_no_button',
                'default'         => 'off',
				'default_on_front'=> 'off',		
				'options'         => array(
					'off' => esc_html__('No'),
					'on'  => esc_html__('Yes'),
				),
			),
		);
        
        
        $GLOBALS[ $this->slug .'_divi_field_indexes'] = array_keys($fields);
        return $fields;
	}


    
    public function render($attrs, $content = null, $render_slug = null) {
        return fr_divi_modules::front_shortcode_render($this->slug, $this->props);  
	}
}

new fr_faq_search_divi_divi_module;