<?php
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if(!defined('ABSPATH')) exit;



class fr_faq_search_on_elementor extends Widget_Base {
	
	public function get_icon() {
		return 'emtr_lcweb_icon';
	}
	
	public function get_name() {
		return 'faq-revo';
	}

	public function get_categories() {
		return array('general');
	}

	public function get_title() {
		return 'FAQ Revolution';
	}



   protected function register_controls() {

		// be sure tax are registered
		include_once(FR_DIR .'/admin_menu.php'); 
		register_cpt_fr_faq();
		
		$subjs_n_childs = array('' => '('. __('none', 'fr_ml') .')') + fr_sub_subsubjs_for_builders();

		////////////////////////////////////////


		// MAIN PARAMS
		$this->start_controls_section(
			'main',
			array(
				'label' => __('Main Parameters', 'fr_ml'),
			)
		);
    
  		$this->add_control(
		   'subj_n_child',
		   array(
			  'label' 	=> __('Predefined subject', 'fr_ml'),
			  'type' 	=> \Elementor\Controls_Manager::SELECT2,
			  'default' => current(array_keys($subjs_n_childs)),
			  'options' => $subjs_n_childs
		   )
		);
  				
		$this->add_control(
		   'req_src',
		   array(
			  'label' 		=> __('Show FAQs only filling searchbar?', 'fr_ml'),
			  'description'	=> '',
			  'type' 		=> Controls_Manager::SWITCHER,
			  'default' 	=> '',
			  'label_on' 	=> __('Yes'),
			  'label_off' 	=> __('No'),
			  'return_value' => '1',
		   )
        );
        
        $this->add_control(
		   'excl_subj',
		   array(
			  'label' 	=> __('Excluded subjects', 'fr_ml'),
			  'type' 	=> \Elementor\Controls_Manager::SELECT2,
              'multiple'=> true, 
			  'default' => false,
			  'options' => fr_sub_subsubjs_for_builders(true)
		   )
		);
		
		$this->end_controls_section();
   }


	
	////////////////////////


	protected function render() {
     	$vals = $this->get_settings();
		//var_dump($vals);
		
		
		$parts = array(
			'subj_n_child', 'req_src', 'excl_subj' 
		);
		$params = '';
		
		foreach($parts as $part) {
			$params .= $part.'="';
			
			if(!isset($vals[$part])) {
                $vals[$part] = '';
            }
            if(is_array($vals[$part])) {
                $vals[$part] = implode(',', $vals[$part]);    
            }
			$params .= $vals[$part].'" ';	
		}
        
		echo do_shortcode('[faq-revo-searchbar '. $params .']');
	}

}
