(function($) { 
	"use strict";
	
	
	var icon = wp.element.RawHTML({
			children: '<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 16 16"><path  d="M10,2C5.58,2,2,5.1,2,9a7,7,0,0,0,4.07,6.1V18l3.78-2h.2c4.37,0,8-3.1,8-7S14.32,2,10,2Zm-.2,11.4a1.13,1.13,0,0,1-1.19-1.1,1.08,1.08,0,0,1,1.19-1.1,1.1,1.1,0,1,1,0,2.2Zm1.59-4.6a2.12,2.12,0,0,0-.69,1.6v.2H8.86v-.3a2.68,2.68,0,0,1,.79-1.9c.4-.6.8-1,.8-1.4s-.3-.7-1-.7a2,2,0,0,0-1.29.4l-.5-1.4a4.46,4.46,0,0,1,2.19-.5c1.79,0,2.58.9,2.58,1.9A3.08,3.08,0,0,1,11.34,8.8Z" transform="translate(-2 -2)"/></svg>'
	});
	
	
		
	// recreate attributes from PHP array
	var atts = {};
	$.each(fr_defaults, function(i, v) {
		atts[i] = {default : v.default};
	});
	
	
	
	
	// trick executing javascript on server rendered element
	window.fr_guten_on_display = function(blockId) {
		setTimeout(function() { // wait a bit for possible guten mess
			
			if(!$('#block-'+ blockId +' .fr_searchbar_form').length || $('#block-'+ blockId +' .components-placeholder').length) {
				setTimeout(function() {
					fr_guten_on_display(blockId);
				}, 350);
				return false;
			}
			
			var data = {
				action      : 'fr_guten_async_render',
                page_url    : window.location.href,
				guten_atts  : $('#block-'+ blockId +' .fr_guten_atts').attr('data-atts')
			};
			$.post(ajaxurl, data, function(response) {
				$('#block-'+ blockId +' .fr_searchbar_form').replaceWith(response);
			});	
			
			// disable click on grid
			$(document).off('click mousedown mouseup', '.wp-block .fr_searchbar_form *').on('click mousedown mouseup', '.wp-block .fr_searchbar_form *', function(e) {
				e.preventDefault();
				return true;
			});
		}, 400);
	};
	
		

	// register block
	var args = {
		block_id			: 'lcweb/faq-revo',
		title				: 'Faq Revolution',
		panels				: {'main' : {title : 'Main Options'}},
		icon				: icon,
		structure			: fr_defaults,
		attributes			: atts,
		on_display_callback : 'fr_guten_on_display',
	};
	lc_register_block(args); 


})(jQuery); 