<?php
// INITIALIZE GUTEN BLOCKS AND DEFINE HANDLERS



// register blocks
function fr_guten_register() {
	if(!function_exists('register_block_type')) {
        return;
    }
	include_once(FR_DIR .'/builders_integration/guten_elements/faq/faq.php');	
}
add_action('init', 'fr_guten_register');






// enqueue scripts in gutenberg 
function fr_guten_scripts() {
    global $current_screen;
    
    $deps = array(
        'wp-blocks',
        'wp-i18n',
        'wp-element',
    );  
    if($current_screen->base != 'widgets') {
        $deps[] = 'wp-editor';     
    }
    
    
	wp_enqueue_script(
		'lc_guten_toolkit',
		FR_URL .'/builders_integration/guten_elements/common.js',
		$deps,
		'1.2.3',
		true
	);
	
	
	
	wp_enqueue_script(
		'lcweb/faq-revo',
		FR_URL .'/builders_integration/guten_elements/faq/faq.js',
		$deps,
		FR_VER, 
		true
	);
	
	
	
	// hook for additional scripts
	if(!did_action('lc_guten_scripts')) {
		$GLOBALS['lc_guten_scripts'] = true;
		do_action('lc_guten_scripts');
	}
}
add_action('enqueue_block_editor_assets', 'fr_guten_scripts');






// hook for custom scripts in gutenberg head
if(!function_exists('lc_scripts_in_guten_head')) {
	function lc_scripts_in_guten_head() {
		do_action('lc_scripts_in_guten_head');
	}
	add_action('admin_head', 'lc_scripts_in_guten_head', 999);
}




// compiling shortcode attributes from an array
function fr_guten_atts_compile($atts) {
	$compiled = array();
	foreach($atts as $key => $val) {
		$val = ($val === true || $val === 'true') ? 1 : esc_attr($val);
		$compiled[] = $key .'="'. $val .'"'; 	
	}

	return implode(' ', $compiled);
}




// remote handler for ServerSideRender blocks
function fr_guten_handler($atts) {
	$code = '';
	
	ob_start();
	fr_inline_css();
	$code .= ob_get_clean();
	
	// compile atts
	$compiled = array();
	foreach($atts as $key => $val) {
        if((string)$val === 'true' || $val === true) {
            $val = '1';    
        }
        elseif((string)$val === 'false' || $val === false) {
            $val = '';    
        }
        
		$compiled[] = $key .'="'. esc_attr($val) .'"'; 	
	}
	
	$code .= '<noscript class="fr_guten_atts" data-atts="'. esc_attr(json_encode($atts)) .'"></noscript>';
	return $code . do_shortcode('[faq-revo-searchbar '. fr_guten_atts_compile($atts) .']');
}



// ajax handler to execute dynamic javascript code on box choice
function fr_guten_async_render() {	
	if(!isset($_POST['page_url'])) {
        wp_die('missing page URL param');   
    }
    
    $query_string = parse_url($_POST['page_url'], PHP_URL_QUERY);
    parse_str($query_string, $query_vars);
    $post_id = isset($query_vars['post']) ? (int)$query_vars['post'] : null;
    
    if(!$post_id || !current_user_can('edit_post', $post_id)) {
        wp_die('forbidden access');   
    }   
    
    $raw_atts = json_decode(stripslashes($_POST['guten_atts']), true);
	wp_die(
        do_shortcode('[faq-revo-searchbar '. fr_guten_atts_compile($raw_atts) .']')
	);
}
add_action('wp_ajax_fr_guten_async_render', 'fr_guten_async_render');




// fixes WP > 5.5 fields type declaration deprecation 
function fr_fix_block_defs($array) {
    foreach($array as $fid => $fdata) {
        $array[$fid]['lc_type'] = $array[$fid]['type'];
        $array[$fid]['type'] = (in_array($array[$fid]['type'], array('number', 'slider'))) ? 'number' : 'string';    
    }
    
    return $array;
}




// fixing Gutenberg front rendering issue with ToggleControl field
function fr_guten_ToggleControl_val_fix($parsed_block) {
    if(isset($parsed_block['blockName']) && strpos($parsed_block['blockName'], 'lcweb/') !== false && isset($parsed_block['attrs']) && is_array($parsed_block['attrs'])) {
        
        foreach($parsed_block['attrs'] as $key => $val) {
  
            if($val === true) {
                $parsed_block['attrs'][$key] = '1';    
            }
            elseif($val === false) {
                $parsed_block['attrs'][$key] = '';    
            }        
        } 
    }
    
    return $parsed_block;
}
add_filter('render_block_data', 'fr_guten_ToggleControl_val_fix', 10);