<?php
// class creating choices HTML code in admin builder

class fr_admin_choices_code {
	
	
	// default choice structure
	private $choice_structure = array(
		'opt_name' 	=> '',
		'on_choice'	=> 'txt_n_end',
		'txt'		=> '',
		'gallery'	=> array(), // associated image IDs
		'kb'		=> array(),	// associated KB article IDs
		'new_quest'	=> '',
		
		'choices'	=> array(), // containing child answers
	);
	
	private $kb_array		= false; // array containing knowledgebase elements (id => name)
	private $ext_link_array	= false; // array containing external links ("ext-"+ id => name)
	
		
	// test FAQ structure
	
	
	
	/* given a choice array, returns its HTML code */
	public function get_code($array = array(), $recursive = false) {
		$code = '';
		
		if(empty($array) || !is_array($array)) {
			$data =	array($this->choice_structure);
		}
		else {
			
			$reset_array = reset($array); // use this standalone on old PHP versions
			$data = (empty($reset_array)) ? array($this->choice_structure) : $array;	
		}

		// debug with test structure
		/*if(!$recursive) {
			$data = $this->test_structure; 
		}*/
		
		
		// actions on choice list
		$aoc_list = array(
			'txt_as_end' 	=> __('Text as end', 'fr_ml'), 	
			'def_solution' 	=> __('Default solution', 'fr_ml'), 	
			'def_user_act'	=> __('Default user action', 'fr_ml'),
			'question' 		=> __('New question', 'fr_ml'), 	 	
		);
		
		
		// build
		foreach($data as $cd) {  
			$toggle_txt_vis = (in_array($cd['on_choice'], array('def_solution', 'def_user_act'))) ? 'style="display: none;"': '';
			$toggle_choices_vis = ($cd['on_choice'] == 'question') ? '' : 'style="display: none;"';
			$child_choice_class	= ($recursive) ? 'fr_child_choice' : '';

			$code .= '
			<div class="fr_choices_row '. $child_choice_class .'">
				<div class="fr_choice"> 
					
					<div>
						<label>'. __('Option name', 'fr_ml') .'</label>
						<input type="text" name="opt_name" value="'. esc_attr($cd['opt_name']) .'" title="'. esc_attr(__('Option name', 'fr_ml')) .'" autocomplete="off" />
					</div>
					
					<hr/>
					<div>
						<label>'. __('What to show on choice?', 'fr_ml') .'</label>
						<select name="fr_on_choice" autocomplete="off">';
						
							foreach($aoc_list as $aoc_id => $aoc_name) {
								$code .= '<option value="'. $aoc_id .'" '. selected($cd['on_choice'], $aoc_id, false) .'>'. $aoc_name .'</option>';		
							}
						
						$code .= '
						</select>
					</div>

					<div class="fr_node_txt" '. $toggle_txt_vis .'>
						<hr/>
						<label>'. __('Text', 'fr_ml') .'</label>
						<textarea name="fr_choice_txt" class="fr_choice_txt">'. $cd['txt'] .'</textarea>
					</div>
					
					<div class="fr_node_extra">
						<hr/>
						<div>
							<label>
								'. __('Attached images', 'fr_ml') .'
								<span class="fr_gallery_add" title="'. esc_attr(__('add image', 'fr_ml')) .'">+</span>
							</label>
							<ul class="fr_choice_gallery">';
							
							foreach($cd['gallery'] as $img_id) {
								$img_data = wp_get_attachment_image_src($img_id);
								$code .= '
								<li data-img-id="'. $img_id .'" style="background-image: url(\''. $img_data[0] .'\');">
									<span class="fr_gallery_del dashicons dashicons-dismiss" title="'. esc_attr(__("remove image", 'fr_ml')) .'"></span>
								</li>';
							}
							
							$code .= '
							</ul>
						</div>
						
						<hr/>
						<div>
							<label>'. __('Linked articles', 'fr_ml') .'</label>
							<select name="fr_linked_kb[]" class="fr_lc_select" multiple="true" autocomplete="off">
								
								<optgroup label="'. __('Knowledge Base Articles', 'fr_ml') .'">';
						
									foreach($this->get_kb_articles() as $kb_id => $kb_name) {
										$selected = (is_array($cd['kb']) && count($cd['kb']) && in_array($kb_id, $cd['kb'])) ? 'selected="selected"' : '';
										$code .= '<option value="'. $kb_id .'" '. $selected .'>'. $kb_name .'</option>';
									}
									
							$code .= '
								</optgroup>
								<optgroup label="'. __('External Links', 'fr_ml') .'">';
								
									foreach($this->get_ext_links() as $el_id => $el_name) {
										$selected = (is_array($cd['kb']) && count($cd['kb']) && in_array($el_id, $cd['kb'])) ? 'selected="selected"' : '';
										$code .= '<option value="'. $el_id .'" '. $selected .'>'. $el_name .'</option>';
									}		
								
						$code .= '
								</optgroup>
							</select>
						</div>	
					</div>

					<div class="fr_node_question" '. $toggle_choices_vis .'>
						<hr/>
						<label>'. __('New question', 'fr_ml') .'</label>
						<input type="text" name="new_quest" value="'. esc_attr($cd['new_quest']) .'" autocomplete="off" />
					</div>


					<ul class="fr_choice_cmd">
						<li class="fr_del_choice">
							<span class="dashicons dashicons-no" title="'. esc_attr(__('delete choice', 'fr_ml')) .'"></span>
						</li>
						<li class="fr_toggle_choices" '. $toggle_choices_vis .'>
							<span class="dashicons dashicons-visibility" title="'. esc_attr(__('toggle choices visibility', 'fr_ml')) .'"></span>
						</li>
						
						<li class="fr_sort_choice fr_move_faq_down">
							<span class="dashicons dashicons-arrow-down-alt2" title="'. esc_attr(__('move down', 'fr_ml')) .'"></span>
						</li>
						<li class="fr_sort_choice fr_move_faq_up">
							<span class="dashicons dashicons-arrow-up-alt2" title="'. esc_attr(__('move up', 'fr_ml')) .'"></span>
						</li>
					</ul>
				</div>
				
				';
				
				// check for childs - recursive composition
				if($cd['on_choice'] == 'question' && !empty($cd['choices'])) {
					$code .= $this->get_code($cd['choices'], true);
				}
				
				$code .= '
			</div>
			<div class="fr_add_choice dashicons dashicons-plus-alt" title="'. esc_attr(__('add choice', 'fr_ml')) .'"><span>'. __('Add choice', 'fr_ml') .'</span></div>';
		}
		
		return $code;	
	}
	
	
	
	////////////////////////////////////////////////
	
	
	
	// get knowledgebase articles array
	public function get_kb_articles($article = false) {
		if($this->kb_array === false) {
			$array = array();
			
			$args = array(
				'post_type'		=> 'fr_kb',
				'numberposts'	=> -1,
				'orderby' 		=> 'title',
				'order'			=> 'ASC',
			);
			$articles = get_posts($args);
			
			if(!is_wp_error($articles) && is_array($articles)) {
				foreach($articles as $article) {
					
					$array[ $article->ID ] = $article->post_title;
				}
			}
			
			$this->kb_array = $array;
		}
		
		return $this->kb_array;		
	}
	
	
	
	// get external links array
	public function get_ext_links($link = false) {
		if($this->ext_link_array === false) {
			$array = array();
			
			$args = array(
				'post_type'		=> 'fr_ext_links',
				'numberposts'	=> -1,
				'orderby' 		=> 'title',
				'order'			=> 'ASC',
			);
			$links = get_posts($args);
			
			if(!is_wp_error($links) && is_array($links)) {
				foreach($links as $link) {
					
					$array[ 'ext-'. $link->ID ] = $link->post_title;
				}
			}
			
			$this->ext_link_array = $array;
		}
		
		return $this->ext_link_array;		
	}
	
		
}