<?php 
// EXTERNAL LINKS POST TYPE - turning excerpt into the link field, JS to check existing links and the CSS to hide the rest


function fr_ext_ilnk_pt_hacks() {
	global $current_screen, $post;

	if(!is_object($current_screen) || !isset($current_screen->id) || $current_screen->id != 'fr_ext_links') {
		return false;	
	}
	
    dike_lc('lcweb', 'fr', true);
	?>
    <style type="text/css">
	#submitdiv > .handlediv,
	#submitdiv > .ui-sortable-handle,
	#submitdiv h2.hndle,
    #submitdiv .handle-actions,
	#minor-publishing,
	#screen-meta-links,
	#postexcerpt .inside > p,
    #postexcerpt .handle-actions,
	#notice {
		display: none !important;	
	}
	</style>
	
    
    <script type="text/javascript">
	// change Excerpt texts to "External URL"
	const exc_head_rename_intval = setInterval(function() { 
        if(document.querySelector('#postexcerpt h2.ui-sortable-handle')) {
            document.querySelector('#postexcerpt h2.ui-sortable-handle').innerHTML = "<?php esc_html_e('External URL', 'fr_ml') ?>";
            clearInterval(exc_head_rename_intval);
        }
    }, 50);
	
	
	jQuery(document).ready(function($) {
     
		var can_save 		= false
			orig_title_val 	= document.getElementById('title').value,
			orig_url_val 	= document.getElementById('excerpt').value;
		


		// perform checks before saving
		$(document).on('click', '#publish', function(e) {
			if(can_save) {
				return true;
			}
			e.preventDefault();
			
			
			var title = $.trim( $('#title').val());
			$('#title').val(title);
			
			var url = $.trim( $('#excerpt').val());
			$('#excerpt').val(url);


			// name and URL must exist
			if(!url || !title) {
				fr_toast_message('error', "<?php _e('Please insert a valid URL', 'fr_ml') ?>");
				return false;	
			}
			
			// check URL conformation
			if(!is_valid_url(url)) {
				fr_toast_message('error', "<?php _e('Please insert a valid URL', 'fr_ml') ?>");
				return false;	
			}
			
			// AJAX check against other links
			var data = {
				action		: 'fr_check_ext_link_unicity',
				link_id		: <?php echo (int)$post->ID ?>,
				fr_title	: title,
				fr_url		: url,
				lcwp_nonce: '<?php echo wp_create_nonce('lcwp_nonce') ?>'
			};
			$('.spinner').css('visibility', 'visible');
				
				
			$.post(ajaxurl, data, function(response) {
				$('.spinner').css('visibility', 'hidden');
				
				if($.trim(response) == 'success') {
					
					can_save = true;
					$('#publish').trigger('click');
				} 
				else {
					fr_toast_message('error', "<?php _e('Another link has the same title or URL', 'fr_ml') ?>");
					return false;	
				}
			});
		});
		
		
		
		// check whether a string is a valid URL 
		var is_valid_url = function(str) {
  			var regexp = /^(?:(?:https?|ftp):\/\/)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/\S*)?$/;
       
	   		return (regexp.test(str)) ? true : false;
		};
		
		
		
		// toast message for ajax operations
		fr_toast_message = function(type, text) {
			if(!jQuery('#lc_toast_mess').length) {
				jQuery('body').append('<div id="lc_toast_mess"></div>');
				
				jQuery('head').append(
				'<style type="text/css">' +
				'#lc_toast_mess,#lc_toast_mess *{-moz-box-sizing:border-box;box-sizing:border-box}#lc_toast_mess{background:rgba(20,20,20,.2);position:fixed;top:0;right:-9999px;width:100%;height:100%;margin:auto;z-index:99999;opacity:0;filter:alpha(opacity=0);-webkit-transition:opacity .15s ease-in-out .05s,right 0s linear .5s;-ms-transition:opacity .15s ease-in-out .05s,right 0s linear .5s;transition:opacity .15s ease-in-out .05s,right 0s linear .5s}#lc_toast_mess.lc_tm_shown{opacity:1;filter:alpha(opacity=100);right:0;-webkit-transition:opacity .3s ease-in-out 0s,right 0s linear 0s;-ms-transition:opacity .3s ease-in-out 0s,right 0s linear 0s;transition:opacity .3s ease-in-out 0s,right 0s linear 0s}#lc_toast_mess:before{content:"";display:inline-block;height:100%;vertical-align:middle}#lc_toast_mess>div{position:relative;padding:13px 16px!important;border-radius:2px;box-shadow:0 2px 17px rgba(20,20,20,.25);display:inline-block;width:310px;margin:0 0 0 50%!important;left:-155px;top:-13px;-webkit-transition:top .2s linear 0s;-ms-transition:top .2s linear 0s;transition:top .2s linear 0s}#lc_toast_mess.lc_tm_shown>div{top:0;-webkit-transition:top .15s linear .1s;-ms-transition:top .15s linear .1s;transition:top .15s linear .1s}#lc_toast_mess>div>span:after{font-family:dashicons;background:#fff;border-radius:50%;color:#d1d1d1;content:"";cursor:pointer;font-size:23px;height:15px;padding:5px 9px 7px 2px;position:absolute;right:-7px;top:-7px;width:15px}#lc_toast_mess>div:hover>span:after{color:#bbb}#lc_toast_mess .lc_error{background:#fff;border-left:4px solid #dd3d36}#lc_toast_mess .lc_success{background:#fff;border-left:4px solid #7ad03a}' +
				'</style>');	
				
				// close toast message
				jQuery(document.body).off('click tap', '#lc_toast_mess');
				jQuery(document.body).on('click tap', '#lc_toast_mess', function() {
					jQuery('#lc_toast_mess').removeClass('lc_tm_shown');
				});
			}
			
			// setup
			if(type == 'error') {
				jQuery('#lc_toast_mess').empty().html('<div class="lc_error"><p>'+ text +'</p><span></span></div>');	
			} else {
				jQuery('#lc_toast_mess').empty().html('<div class="lc_success"><p>'+ text +'</p><span></span></div>');	
				
				setTimeout(function() {
					jQuery('#lc_toast_mess.lc_tm_shown span').trigger('click');
				}, 2150);	
			}
			
			// use a micro delay to let CSS animations act
			setTimeout(function() {
				jQuery('#lc_toast_mess').addClass('lc_tm_shown');
			}, 30);	
		};
		

    });
	</script>
	<?php
}
add_action('admin_footer', 'fr_ext_ilnk_pt_hacks');




/*//////////////////////////
// REGISTER
function fr_ext_links_register_metaboxes() {
	add_meta_box('fr_ext_link_type_box', __('Link', 'fr_ml'), 'fr_ext_link_box', 'fr_ext_links', 'normal', 'default');
}
add_action('admin_init', 'fr_ext_links_register_metaboxes');



function fr_ext_link_box() {
	global $post;
	?>
    <
    <textarea></textarea>
    <input type="text" name="fr_faq_noncename" value="<?php echo wp_create_nonce('lcwp_nonce') ?>" />
	<?php
	return true;	
}

*/