<?php


////////////////////////////////////////////////
////// LOAD FAQs LIST ON SEARCH PAGE ///////////
////////////////////////////////////////////////

function fr_get_faqs_list() {	
	if(!isset($_POST['fr_id']) || !isset($_POST['subj']) || !filter_var($_POST['subj'], FILTER_VALIDATE_INT)) {
        wp_die('Missing subject');
    }
	$subj = (int)$_POST['subj'];
	
	if(!isset($_POST['sub_subj']) || empty($_POST['sub_subj'])) {
		$sub_subj =	'any';	
	}
	else {
		if(!filter_var($_POST['sub_subj'], FILTER_VALIDATE_INT) && $_POST['sub_subj'] != 'any') {
            wp_die('Wrong sub-subject');
        }
		$sub_subj = ($_POST['sub_subj'] == 'any') ? 'any' : (int)$_POST['sub_subj'];
	}
	
    $excl_subj = (isset($_POST['excl_subj']) && is_array($_POST['excl_subj'])) ? $_POST['excl_subj'] : array();
    
	
	// which term to search for?
	$match_against = ($sub_subj == 'any') ? $subj : $sub_subj;
	
	// require search mode?
	$req_src = (isset($_POST['req_src']) && $_POST['req_src']) ? 1 : 0;
	
	wp_die(fr_front_search_get_faqs($_POST['fr_id'], $match_against, $req_src, false, $excl_subj));
}
add_action('wp_ajax_fr_get_faqs', 'fr_get_faqs_list');
add_action('wp_ajax_nopriv_fr_get_faqs', 'fr_get_faqs_list');





////////////////////////////////////////////////
////// LOAD FAQ AFTER SEARCH RESULTS CLICK /////
////////////////////////////////////////////////

function fr_load_faq() {	
	if(!isset($_POST['fid']) || !filter_var($_POST['fid'], FILTER_VALIDATE_INT)) {
        wp_die('FAQ ID missing');
    }
	$faq_id = (int)$_POST['fid'];
	
	wp_die(fr_front_faq_code($faq_id));
}
add_action('wp_ajax_fr_load_faq', 'fr_load_faq');
add_action('wp_ajax_nopriv_fr_load_faq', 'fr_load_faq');






////////////////////////////////////////////////
////// FAQ VOTE ////////////////////////////////
////////////////////////////////////////////////

function fr_vote_faq() {	
	if(!isset($_POST['fid']) || !filter_var($_POST['fid'], FILTER_VALIDATE_INT)) {
        wp_die('FAQ ID missing');
    }
	$faq_id = (int)$_POST['fid'];
	
	if(get_post_status($faq_id) != 'publish') {
		wp_die('FAQ not found');		
	}
	
	// check for already voted
	$cookie_name = 'fr_faq_'. $faq_id .'_vote';
	if(isset($_COOKIE[$cookie_name])) {
		wp_die('This FAQ has already been voted by you');	
	}
	
	
	// vote
	if(!isset($_POST['fr_vote']) || !in_array($_POST['fr_vote'], array('up', 'down'))) {
        wp_die('Vote missing');
    }
	$vote = $_POST['fr_vote'];
	
	
	// apply
	$key = ($vote == 'up') ? 'fr_upvotes' : 'fr_downvotes';
	
	$curr = (int)get_post_meta($faq_id, $key, true);  
	update_post_meta($faq_id, $key, ($curr+1));
	
	
	// set cookie
	setcookie($cookie_name, $vote, time() + (86400 * 999999), "/"); // 86400 = 1 day
	
	wp_die('success');
}
add_action('wp_ajax_fr_vote_faq', 'fr_vote_faq');
add_action('wp_ajax_nopriv_fr_vote_faq', 'fr_vote_faq');

