<?php
////////////////////////////////////
// DYNAMIC CSS FILE CREATION ///////
////////////////////////////////////
?>



<?php if(fr_opt_to_val('fr_wrap_max_w', false, false, false) < 2000) : ?>
/* WRAP MAX-WIDTH */
.fr_searchbar_form,
.fr_faq_contents {
	max-width: <?php fr_opt_to_val('fr_wrap_max_w', 'px') ?>;
    
	<?php if(get_option('fr_center_wrap')) : ?>
	margin: auto;
	<?php endif; ?>
}
<?php endif; ?>



/* TYPOGRAPHY */
.fr_searchbar_form,
.fr_faq_choice_wrap {
	font-size: <?php fr_opt_to_val('fr_main_font_size', 'px') ?>;
}
@media screen and (max-width: 860px) { 
	.fr_searchbar_form,
	.fr_faq_choice_wrap {
		font-size: <?php fr_opt_to_val('fr_mobile_font_size', 'px') ?>;
	}
}

.fr_custom_dd section,
.fr_faq_search input {
	font-size: <?php fr_opt_to_val('fr_dd_sel_font_size', '%') ?>;
}
.fr_custom_dd_list li {
	font-size: <?php fr_opt_to_val('fr_dd_opt_font_size', '%') ?>;
}
.fr_faqs_list li {
	font-size: <?php fr_opt_to_val('fr_faqs_list_font_size', '%') ?>;
}
h3.fr_faq_main_title {
	font-size: <?php fr_opt_to_val('fr_faq_title_font_size', '%') ?>;
    
    <?php if(get_option('fr_faq_title_font_family')) : ?>
    	font-family: "<?php fr_opt_to_val('fr_faq_title_font_family') ?>"; 
    <?php endif; ?>
}
.fr_faq_container .fr_main_faq_txt,
.fr_faq_container .fr_choice_kb {
	font-size: <?php fr_opt_to_val('fr_faq_txt_font_size', '%') ?>;
}
h4.fr_new_question {
	font-size: <?php fr_opt_to_val('fr_faq_questions_font_size', '%') ?>;
}
h6.fr_choice_kb_legend {
	font-size: <?php echo (int)fr_opt_to_val('fr_faq_txt_font_size', false, false, false) + 3 ?>%;
}	



/* DROPDOWN IMAGES */
<?php
$dd_img_sizes 		= fr_opt_to_val('fr_dd_img_sizes', false, false, false);
$dd_img_sizes_mob 	= fr_opt_to_val('fr_dd_img_sizes_mob', false, false, false);
?>
.fr_subj_img {
	max-width: <?php echo (int)$dd_img_sizes[0] ?>px; 
    max-height: <?php echo (int)$dd_img_sizes[1] ?>px; 
    border-radius: <?php fr_opt_to_val('fr_dd_img_radius', '%') ?>;
}
@media screen and (max-width: 860px) { 
	.fr_subj_img {
        max-width: <?php echo (int)$dd_img_sizes_mob[0] ?>px; 
        max-height: <?php echo (int)$dd_img_sizes_mob[1] ?>px; 
    }
}



/* FAQ IMG GALLERY OVERLAY */
<?php if(!(int)get_option('fr_faq_img_overlay')) : ?>
.fr_choice_gall_inner a:before {
	display: none !important;
}
<?php endif; ?>

.fr_choice_gall_inner a:before {
	color: <?php fr_opt_to_val('fr_img_ol_icon') ?>;
    background: <?php echo fr_hex2rgba(
		fr_opt_to_val('fr_img_ol_bg', false, false, false), 
		fr_opt_to_val('fr_img_ol_bg_opacity', false, true, false)
	) ?>;
}
.fr_choice_gall_inner a:hover:before {
	color: <?php fr_opt_to_val('fr_img_ol_icon_h') ?>;
    background: <?php echo fr_hex2rgba(
		fr_opt_to_val('fr_img_ol_bg_h', false, false, false), 
		fr_opt_to_val('fr_img_ol_bg_opacity_h', false, true, false)
	) ?>;
}



/* ELEMS BORDER */
.fr_custom_dd, 
.fr_faq_search input {
	border: <?php fr_opt_to_val('fr_dd_border_size') ?>px <?php fr_opt_to_val('fr_dd_border_style') ?> <?php fr_opt_to_val('fr_dd_border_col') ?>; 
}
.fr_custom_dd_list li {
	border-color: <?php fr_opt_to_val('fr_dd_border_col') ?>;
}

.fr_custom_dd:hover,
.fr_custom_dd.fr_expanded_dd, 
.fr_faq_search input:hover,
.fr_faq_search input:active,
.fr_custom_dd.fr_expanded_dd {
	border-color: <?php fr_opt_to_val('fr_dd_border_col_h') ?>; 
}

.fr_faqs_list li {
	border: <?php fr_opt_to_val('fr_faqs_list_border_size') ?> <?php fr_opt_to_val('fr_faqs_list_border_style') ?> <?php fr_opt_to_val('fr_faqs_list_border_col') ?>; 
}
.fr_faqs_list li:hover {
	border-color: <?php fr_opt_to_val('fr_faqs_list_border_col_h') ?>; 
}

.fr_faq_container {
	border: <?php fr_opt_to_val('fr_faq_border_size') ?> <?php fr_opt_to_val('fr_faq_border_style') ?> <?php fr_opt_to_val('fr_faqs_border_col') ?>; 
}
.fr_sub_choice_hr {
	border-top: <?php fr_opt_to_val('fr_sep_border_size') ?> <?php fr_opt_to_val('fr_sep_border_style') ?> <?php fr_opt_to_val('fr_faq_sep_border_col') ?>; 
}



/* ELEMS BORDER RADIUS */
.fr_custom_dd, 
.fr_faq_search input,
.fr_faqs_list li,
.fr_faq_container,
.fr_back_to_faqs {
	border-radius: <?php fr_opt_to_val('fr_elem_radius', 'px') ?>;
}
.fr_subj_img {
	border-radius: <?php fr_opt_to_val('fr_dd_img_radius', '%') ?>;
}



/* COLORS */
.fr_custom_dd, 
.fr_faq_search input { 
	color: <?php fr_opt_to_val('fr_dd_txt_col') ?>;
    background: <?php fr_opt_to_val('fr_dd_bg_col') ?>;
}
.fr_custom_dd section:before,
.fr_faq_search:before,
.fr_clear_search {
 	color: <?php fr_opt_to_val('fr_dd_txt_col') ?>;
 }
.fr_custom_dd:hover,
.fr_custom_dd.fr_expanded_dd, 
.fr_faq_search:hover input,
.fr_faq_search input:active {
	color: <?php fr_opt_to_val('fr_dd_txt_col_h') ?>;
    background: <?php fr_opt_to_val('fr_dd_bg_col_h') ?>;
}
.fr_custom_dd:hover section:before,
.fr_custom_dd.fr_expanded_dd section:before,
.fr_faq_search:hover:before {
	color: <?php fr_opt_to_val('fr_dd_txt_col_h') ?>;
}
.fr_faqs_list li {
	color: <?php fr_opt_to_val('fr_faqs_list_txt_col') ?>;
    background: <?php fr_opt_to_val('fr_faqs_list_bg_col') ?>;
}
.fr_faqs_list li:before {
	color: <?php fr_opt_to_val('fr_faqs_list_txt_col') ?>;
}
.fr_faqs_list li:hover {
	color: <?php fr_opt_to_val('fr_faqs_list_txt_col_h') ?>;
    background: <?php fr_opt_to_val('fr_faqs_list_bg_col_h') ?>;
}
.fr_faqs_list li:hover:before {
	color: <?php fr_opt_to_val('fr_faqs_list_txt_col_h') ?>;
}

.fr_faq_container {
	background: <?php fr_opt_to_val('fr_faqs_bg_col') ?>;
}
.fr_big_loader {
	<?php $loader_rgba = fr_hex2rgba( get_option('fr_loader_col', '#aaa'), '0.3') ?>
	border-color: <?php echo $loader_rgba.' '.$loader_rgba.' '.$loader_rgba ?> <?php fr_opt_to_val('fr_loader_col') ?>;
}
.fr_faq_container .fr_main_faq_txt,
.fr_faq_container .fr_faq_txt,
.fr_faq_container .fr_choice_kb_legend,
.fr_faq_container .fr_choice_kb,
.fr_faq_container .fr_rating_box {
	color: <?php fr_opt_to_val('fr_faqs_txt_col') ?>;
}

.fr_faq_container .fr_choice_kb a {
	color: <?php fr_opt_to_val('fr_faqs_link_col') ?>;
}
.fr_faq_container .fr_choice_kb a:hover,
.fr_faq_container .fr_choice_kb a:visited {
	color: <?php fr_opt_to_val('fr_faqs_link_col_h') ?>;
}

.fr_back_to_faqs {
	color: <?php fr_opt_to_val('fr_btfl_col') ?>;
    background: <?php fr_opt_to_val('fr_btfl_bg') ?>; 
}
.fr_back_to_faqs:hover {
	color: <?php fr_opt_to_val('fr_btfl_col_h') ?>;
    background: <?php fr_opt_to_val('fr_btfl_bg_h') ?>;
}



/* LIGHTBOX */
.fr_lb .sl-navigation button,
.fr_lb .sl-close {
	color: <?php fr_opt_to_val('fr_lb_icons') ?>;
}
.fr_lb .sl-spinner {
	border-color: <?php fr_opt_to_val('fr_lb_icons') ?>;
}
.sl-overlay {
	background: <?php echo fr_hex2rgba(
		fr_opt_to_val('fr_lb_ol_bg', false, false, false), 
		fr_opt_to_val('fr_lb_ol_bg_opacity', false, true, false)
	) ?>;
}



/* KB TAGS - use FAQ list colors */
<?php if(!get_option('fr_faqs_list_border_size')) : ?>
.fr_kb_tags_buttons a,
.fr_kb_tags_buttons a:visited,
.fr_kb_tags_buttons a:hover {
	border-color: transparent !important; 
}
<?php else : ?>
.fr_kb_tags_buttons a,
.fr_kb_tags_buttons a:visited {
	border-color:<?php fr_opt_to_val('fr_faqs_list_border_col') ?>;
}
.fr_kb_tags_buttons a:hover {
	border-color:<?php fr_opt_to_val('fr_faqs_list_border_col_h') ?>;
}
<?php endif; ?>
.fr_kb_tags_buttons a,
.fr_kb_tags_buttons a:visited {
	border-radius: <?php fr_opt_to_val('fr_elem_radius', 'px') ?>;
    color:<?php fr_opt_to_val('fr_faqs_list_txt_col') ?>;
    background:<?php fr_opt_to_val('fr_faqs_list_bg_col') ?>;
}
.fr_kb_tags_buttons a:hover {
	color:<?php fr_opt_to_val('fr_faqs_list_txt_col_h') ?>;
	border-color:<?php fr_opt_to_val('fr_faqs_list_border_col_h') ?>;
    background:<?php fr_opt_to_val('fr_faqs_list_bg_col_h') ?>;
}



<?php
    
// Divi CSS fixes
if(class_exists('ET_Builder_Module')):      
?>    
.fr_choice_gall_inner.justified-gallery > a > .caption, 
.fr_choice_gall_inner.justified-gallery > div > .caption, 
.fr_choice_gall_inner.justified-gallery > figure > .caption {
	padding: 5px;
	background-color: #000000;
	left: 0;
	right: 0;
	margin: 0;
	color: white;
	font-size: 12px;
	font-weight: 300;
	font-family: sans-serif;
}   
.fr_choice_gall_wrap .jg-entry img {
	min-height: 100% !important;
	transform: translateY(-5px);
}

<?php    
endif;

// FR-ACTION - allow CSS to be inserted before mg_custom_css
do_action('fr_custom_css');


// custom CSS
echo get_option('fr_custom_css');
?>