<?php

// get the current URL
function fr_curr_url() {
	$pageURL = 'http';
	
	if ((isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on") || (funcction_exists('is_ssl') && is_ssl())) {$pageURL .= "s";}
	$pageURL .= "://" . $_SERVER['HTTP_HOST'].$_SERVER["REQUEST_URI"];

	return $pageURL;
}
	
	
	

function fr_getPrefixedCss($css,$prefix) {
    # Wipe all block comments
    $css = preg_replace('!/\*.*?\*/!s', '', $css);

    $parts = explode('}', $css);
    $keyframeStarted = false;
    $mediaQueryStarted = false;

    foreach($parts as &$part) {
        $part = trim($part); # Wht not trim immediately .. ?
        if(empty($part)) {
            $keyframeStarted = false;
            continue;
        }
        else { # This else is also required
            $partDetails = explode('{', $part);

            if (strpos($part, 'keyframes') !== false) {
                $keyframeStarted = true;
                continue;
            }

            if($keyframeStarted) {
                continue;
            }

            if(substr_count($part, "{")==2) {
                $mediaQuery = $partDetails[0]."{";
                $partDetails[0] = $partDetails[1];
                $mediaQueryStarted = true;
            }

            $subParts = explode(',', $partDetails[0]);
            foreach($subParts as &$subPart) {
                if(trim($subPart)==="@font-face") continue;
                else $subPart = $prefix . ' ' . trim($subPart);
            }

            if(substr_count($part,"{")==2) {
                $part = $mediaQuery."\n".implode(', ', $subParts)."{".$partDetails[2];
            }
            elseif(empty($part[0]) && $mediaQueryStarted) {
                $mediaQueryStarted = false;
                $part = implode(', ', $subParts)."{".$partDetails[2]."}\n"; //finish media query
            }
            else {
                if(isset($partDetails[1]))
                {   # Sometimes, without this check,
                    # there is an error-notice, we don't need that..
                    $part = implode(', ', $subParts)."{".$partDetails[1];
                }
            }

            unset($partDetails, $mediaQuery, $subParts); # Kill those three ..
        }   unset($part); # Kill this one as well
    }

    # Finish with the whole new prefixed string/file in one line
    return(preg_replace('/\s+/',' ',implode("} ", $parts)));
}



// handles custom CSS written in LESS and returns a CSS string
function fr_custom_css_less_parser() {
    ob_start();
    include_once(FR_DIR.'/frontend_css.php');

    $css = ob_get_clean();
    if(!trim($css)) { 
        return '';    
    }

    // Divi fix
    if(class_exists('DiviExtension')) {
        $css .= str_replace(';', ' !important;', fr_getPrefixedCss($css, '#et-boc .et-l'));
    }
    
    return $css;
}



/* 
 * Create the frontend CSS
 * @param (bool) $skip_if_file_exists - true to not act if customm CSS file already exists
 */
function fr_create_dynamic_css($skip_if_file_exists = false) {	
	global $wp_filesystem;
    $filepath = FR_DIR .'/css/custom.css';
    
	if(empty($wp_filesystem)) {
		require_once (ABSPATH .'/wp-admin/includes/file.php');
		WP_Filesystem();
	}
    
        
    $versioning_key = 'fr_dynamic_css_versioning';
    $versioning = array(
        'fr' => FR_VER
    );
    $versioning = apply_filters($versioning_key, $versioning);
    ksort($versioning);
        
        
    
    if($skip_if_file_exists && $wp_filesystem->exists($filepath) && md5(json_encode($versioning)) == get_option($versioning_key)) {
        return true;   
    }
	
	$css = fr_custom_css_less_parser();
	if(trim($css) != '') {
        
        $versioning_pre = array();
            foreach($versioning as $subj => $ver) {
                $versioning_pre[] = $subj .' > '.$ver;   
            }
            $versioning_pre = '/* '. implode(' | ', $versioning_pre) .' */
';
        
		if(!$wp_filesystem->put_contents($filepath, $versioning_pre.$css)) {
            update_option('fr_inline_css', 1, false);
			$error = true;
		}
		else {
            update_option($versioning_key, md5(json_encode($versioning)), false);
			update_option('fr_dynamic_scripts_id', md5($css));	
		}
	}
	else {
		if($wp_filesystem->exists($filepath))	{
			wp_delete_file($filepath);
		}
	}
	
	return (isset($error)) ? false : true;
}

    
    
/* Be sure... well read the function name */
function fr_be_sure_dynamic_css_exists() {
    if(!get_option('fr_inline_css')) {
        fr_create_dynamic_css(true);
    }
}




//////////////////////////////////////////////////////////




// get FAQ subjects list array array(term_id => term_data) 
function fr_get_subjs($sel_subj = false, $child_of = 0) {
	if(!isset($GLOBALS['fr_subjs'])) {
		$GLOBALS['fr_subjs'] = array();
	}
	
	// check cache
	if(isset($GLOBALS['fr_subjs'][$child_of])) {
		$subjs = $GLOBALS['fr_subjs'][$child_of];	
	}
	else {
        $def_sorting = get_option('fr_default_sorting', 'name_asc');
        $def_orderby = (strpos($def_sorting, 'name') !== false) ? 'name' : 'term_id';
        $def_order   = (strpos($def_sorting, 'asc') !== false) ? 'ASC' : 'DESC';
            
		$args = array(
			'taxonomy' 		=> 'fr_faq_subjs',
			'hide_empty'	=> false,
			'orderby'		=> $def_orderby,
            'order'         => $def_order, 
		);
		if($child_of !== false) {
			$args['parent'] = $child_of;
		}
		
		$subjs = get_terms('fr_faq_subjs', $args);
		
        // elaborate custom sorting
        $new_key_subjs = array();
        $a = 0;
        foreach($subjs as $s) {
            $new_key_subjs[ (int)fr_get_term_meta($s->term_id, 'fr_subj_order') .'-'. $a] = $s; 
            $a++;
        }
        ksort($new_key_subjs, SORT_NATURAL);
        
        $GLOBALS['fr_subjs'][$child_of] = $new_key_subjs;
	}
	
		
	if(empty($subjs) || !is_array($subjs) || is_wp_error($subjs)) {
		return array();
	}
	
	$subjs_list = array();
	foreach($subjs as $subj) {
		
		// if disabled - skip
		if(fr_get_term_meta($subj->term_id, 'fr_disable_subj')) {
			continue;	
		}
		
		// add image ID to term data 
		if(!$child_of) {
			$subj->fr_img = fr_get_term_meta($subj->term_id, 'fr_subj_img');	
		}
		$subjs_list[ $subj->term_id ] = $subj;	
	}
	
	if($sel_subj) {
		return (isset($subjs_list[$sel_subj])) ? $subjs_list[$sel_subj] : false;	
	}
	
	return $subjs_list;
}



// given a subject term object, returns its name prepending the eventual image
function fr_subj_name($subj_data) {
	
	if(empty($subj_data->fr_img)) {
		$img = '';
	} else {
		$img_data = wp_get_attachment_image_src($subj_data->fr_img); 
		$img = '<img src="'. $img_data[0] .'" class="fr_subj_img" alt="'. esc_attr(get_the_title($subj_data->fr_img)) .'" /> ';
	}
	
	return $img . $subj_data->name;	
}



// given an array of top-leven subjects, returns a JSON string composed by arrays to fill sub-subjects dropdown
function fr_sub_subjs_json($fr_id, $subjs) {
	$array = array(); 
	
	foreach($subjs as $subj_id => $subj_data) {
		$array[$subj_id] = array();
	
		foreach( fr_get_subjs(false, $subj_id) as $term_id => $term_data) {
			$array[$subj_id][$term_id] = array(
				'name' 	=> $term_data->name,
				'dl'	=> fr_term_data_to_dl($term_data)
			);	
		}
	}
	
	return '
	<script type="text/javascript">
	fr_sub_subjs_list["'. $fr_id .'"] = "'. addslashes(json_encode($array)) .'";
	fr_sub_subjs_list["'. $fr_id .'"] = (typeof(fr_sub_subjs_list["'. $fr_id .'"]) != "undefined") ? jQuery.parseJSON(fr_sub_subjs_list["'. $fr_id .'"]) : false;
	</script>';	
}



// given term data, returns its deeplink
function fr_term_data_to_dl($data) {
	$dl_type = get_option('fr_subj_deepl_type', 'slug');
	
	switch($dl_type) {
		case 'slug'	:
		default		:
			$dl = $data->slug;
			break;
		
		case 'id_name' :
			$dl = $data->term_id .'-'. trim(sanitize_title($data->name));
			break;
		
		case 'slug_name' :
			$dl = $data->slug .'|'. trim(sanitize_title($data->name));
			break;
	}
	
	return $dl;	
}



// given the deeplinked part, returns the subject term ID
function fr_deepl_to_term_id($dl) {
	if(empty($dl)) {
		return false;	
	}
	
	$dl_type = get_option('fr_subj_deepl_type', 'slug');
	
	switch($dl_type) {
		case 'slug'	:
		default		:
			$field 	= 'slug';
			$val 	= $dl;
			break;
		
		case 'id_name' :
			$field = 'id';
			
			$arr = explode('-', $dl);
			$val = (int)$arr[0];
			break;
		
		case 'slug_name' :
			$field = 'slug';
			
			$arr = explode('|', $dl);
			$val = (int)$arr[0];
			break;
	}
	
	$term = get_term_by($field, $val, 'fr_faq_subjs');
	return ($term) ? $term->term_id : false;
}



// given sub-subject terms, return dropdown 
function fr_sub_subj_dd($terms) {
	
	$deepl_sub_subj = (isset($_REQUEST['fr_sub_subj']) && $_REQUEST['fr_sub_subj'] != 'any') ? $_REQUEST['fr_sub_subj'] : '';
	$deepl_subj_id 	= fr_deepl_to_term_id($deepl_sub_subj);
	$GLOBALS['fr_sel_sub_subj_id'] = ($deepl_subj_id && isset($terms[ $deepl_subj_id ])) ? $deepl_subj_id : '';	

	$code = 
	'<select name="fr_sub_subj" autocomplete="off">
		<option value="any">'. __('Any', 'fr_ml') .' '. get_option('fr_sub_subj_name', 'section') .'</option>';
					
		foreach($terms as $term_id => $term_data) {
			$code .= 
			'<option value="'. $term_id .'" '. selected($GLOBALS['fr_sel_sub_subj_id'], $term_id, false) .' data-dl="'. fr_term_data_to_dl($term_data) .'">
				'. $term_data->name .
			'</option>';	
		}
		
		return $code .
	'</select>';
}




// simply retrieves FAQs declaring which subject id to match
function fr_front_search_get_faqs($fr_id, $subj_id, $req_src_mode = false, $sel_faq = false, $excl_subj = array()) {
	$faqs 	= fr_get_faqs($subj_id);		
	
	$code 	= '<div class="fr_no_result" style="display: none;"><em>'. do_shortcode(get_option('fr_nores_txt')) .'</em></div>';	
	
	// no FAQs found	
	if(empty($faqs)) {
		return $code .='
		<script type="text/javascript">
		jQuery(document).ready(function($) {
			$("#'. $fr_id .' .fr_no_result").fadeIn(100);	
			$("#'. $fr_id .' .fr_faq_search").hide();
		});
		</script>';
	}
		
	else {
		$sel_faq_class = (empty($sel_faq)) ? '' : 'fr_chosen_faq';
		
		$code .= '
		<script type="text/javascript">
		jQuery(document).ready(function($) {';
		
			$code .= (count($faqs) > 1 && !$sel_faq) ? '$("#'. $fr_id .' .fr_faq_search").val("").show();' : '$("#'. $fr_id .' .fr_faq_search").hide();'; 
		
		$code .= '
			$("#'. $fr_id .' .fr_faqs_wrap").fadeIn(100);
		});
		</script>
		
		<div class="fr_faqs_wrap" style="display: none;">
			<div class="fr_faqs_inner_wrap '. $sel_faq_class .'">
				<ul class="fr_faqs_list">';
			
					foreach($faqs as $faq) {
                        
                        // check excluded ones
                        if(!empty($excl_subj) && fr_faq_is_in_excl_subj($faq->ID, $excl_subj)) {           
                            continue;
                        }
                        
                        // edit FAQ link for admins
						$edit_cmd = (current_user_can('manage_options')) ? 
							'<a class="et_edit_faq dashicons dashicons-edit" title="'. __('edit') .'" href="'.admin_url().'post.php?post='. $faq->ID .'&action=edit" target="_blank"></a>' : '';	
						
						// wrap up texts to be used by JS search
						$search_attr_vals = esc_attr(strip_tags($faq->post_excerpt .' '. get_post_meta($faq->ID, 'fr_search_helper', true))); 
						
						// search required mode?
						$rsc = ($req_src_mode) ? 'style="display: none;"' : '';
						
						// faq listing code	
						$code .= 
						'<li data-val="'. $faq->ID .'" data-dl="'. $faq->ID .'-'. sanitize_title(strip_tags($faq->post_title)) .'" data-searchable="'. $search_attr_vals .'" '. $rsc .'>'. 
							$faq->post_title . $edit_cmd .
						'</li>';
					}
				
				$code .=
				'</ul>
				<div class="fr_faq_container">
					'. fr_front_faq_code($sel_faq) .'
				</div>
				
				<div style="clear: both;"></div>
			</div>
		</div>';
		
		return $code;	
	}
}



// subject + sub-subjects array for builders
function fr_sub_subsubjs_for_builders($strip_subj_in_subsubj = false) {
	$array = array();
	
	$subjs = fr_get_subjs();
	foreach($subjs as $subj_id => $subj_data) {
		
        $key = ($strip_subj_in_subsubj) ? $subj_id : $subj_id.'|';
		$array[$key] = $subj_data->name;
		
        if(!get_option('fr_no_sub_subjs')) {
			
			$childs = fr_get_subjs(false, $subj_id);
			foreach($childs as $child_id => $child_data) {
				
                $key = ($strip_subj_in_subsubj) ? $child_id : $subj_id.'|'.$child_id;
				$array[$key] = $subj_data->name .' - '. $child_data->name;	
			}
		}
		
	}
	
	return $array;	
}



// know if FAQ belongs to excluded FAQ subjects
function fr_faq_is_in_excl_subj($faq_id, $excl_subjs) {
	$linked_subjs = wp_get_post_terms($faq_id, 'fr_faq_subjs');
    
    if(empty($linked_subjs)) {
        return false;    
    }
    
    $belongs = false;
    foreach($linked_subjs as $ls) {
        
        if(in_array($ls->term_id, $excl_subjs)) {
            $belongs = true;
            break;
        }
    }
    
    return $belongs;
}




//////////////////////////////////////////////////////////




// FAQ subject - echoes image picker field
function fr_subj_img_field($img_id = '') {
	wp_enqueue_media();
	
	$has_img_class 	= ($img_id) ? 'fr_subj_has_img' : '';
	$img_data 		= ($img_id) ? wp_get_attachment_image_src($img_id) : array();
	$bg_code		= (empty($img_data)) ? '' : 'style="background-image: url(\''. $img_data[0] .'\')"';
	?>
    
	<div class="fr_subj_img_trigger <?php echo $has_img_class ?>" <?php echo $bg_code ?>>	
		
        <span class="fr_subj_img_del dashicons dashicons-dismiss" title="<?php echo esc_attr(__("remove image", 'fr_ml')) ?>"></span>
        <input type="hidden" name="fr_subj_img" value="<?php echo $img_id ?>" autocomplete="off" /> 
	</div>
	
	<script type="text/javascript">
    (function($) { 
        "use strict";     
        	
        let fr_lb_frame = false;

        $(document).on('click', '.fr_subj_img_trigger', function(e) {
            if($(e.target).hasClass('fr_subj_img_del')) {
                return false;
            }	

            /* Create the media frame */
            fr_lb_frame = wp.media.frames.file_frame = wp.media({
              title		: "FAQ Revolution - <?php echo esc_attr(__("Subject Image Picker", 'fr_ml')) ?>",
              button	: {
                text	: "<?php _e('Select') ?>",
              },
              library 	: {type : 'image'},
              multiple	: false
            });

            /* When an image is selected, run a callback. */
            fr_lb_frame.on('select', function() {
                var code = '',
                    img_data = fr_lb_frame.state().get('selection').toJSON();

                $.each(img_data, function(i, v) {				
                    $('[name=fr_subj_img]').val(v.id);

                    var img = (typeof(v.sizes.thumbnail) != 'undefined') ? v.sizes.thumbnail : v.sizes.full;

                    $('.fr_subj_img_trigger').addClass('fr_subj_has_img').css('background-image', "url('"+ img.url +"')")
                    return false;
                });
            });

            fr_lb_frame.open();
        });


        /* image removal */
        $(document).on('click', '.fr_subj_img_del', function() {
            $('.fr_subj_img_trigger').removeClass('fr_subj_has_img').removeAttr('style');
            $('[name=fr_subj_img]').val('');
        });
    })(jQuery);
    </script> 
	<?php
}




//////////////////////////////////////////////////////////




// set or get a term meta - function created to take advantage of get_term_meta() since WP 4.4
function fr_set_term_meta($term_id, $key, $value) {
	
	if(version_compare(get_bloginfo('version'), '4.4', '>=') ) {
		
		return update_term_meta($term_id, $key, $value);
	} else {
		return update_option($key.'-'.$term_id, $value);
	}
}

function fr_get_term_meta($term_id, $key, $check_old = false) { // check_old = recursive system to force WP_option check
	
	if(!$check_old && version_compare(get_bloginfo('version'), '4.4', '>=') ) {
		
		$val = get_term_meta($term_id, $key, true);
		return (empty($val)) ? fr_get_term_meta($term_id, $key, true) : $val;
	} 
	else {
		return get_option($key.'-'.$term_id);
	}
}

function fr_del_term_meta($term_id, $key) {
	
	delete_term_meta($term_id, $key);
	delete_option($key.'-'.$term_id);
}




//////////////////////////////////////////////////////////




// convert HEX to RGB
function fr_hex2rgb($hex) {
   	// if is RGB or transparent - return it
    $three_chars_pattern = '/^#[a-f0-9]{3}$/i';
    $six_chars_pattern = '/^#[a-f0-9]{6}$/i';

    if(empty($hex) || $hex == 'transparent' || (!preg_match($three_chars_pattern, $hex) && !preg_match($six_chars_pattern, $hex))) {
        return $hex;
    }
  
	$hex = str_replace("#", "", $hex);
   	if(strlen($hex) == 3) {
		$r = hexdec(substr($hex,0,1).substr($hex,0,1));
		$g = hexdec(substr($hex,1,1).substr($hex,1,1));
		$b = hexdec(substr($hex,2,1).substr($hex,2,1));
	} else {
		$r = hexdec(substr($hex,0,2));
		$g = hexdec(substr($hex,2,2));
		$b = hexdec(substr($hex,4,2));
	}
	$rgb = array($r, $g, $b);
  
	return 'rgb('. implode(",", $rgb) .')'; // returns the rgb values separated by commas
}



// hex color to RGBA
function fr_hex2rgba($hex, $alpha) {
	$rgba = str_replace(array('rgb', ')'), array('rgba', ', '.$alpha.')'), fr_hex2rgb($hex));
	return $rgba;	
}



// given a settings field name, returns its default value
function fr_opt_to_def_val($opt_name) {
	include_once(FR_DIR .'/settings/structure.php');
	
	foreach($GLOBALS['fr_settings_structure'] as $sect_id => $sect_data) {	
		foreach($sect_data as $ss_id => $ss_data) {
	
			if(isset( $ss_data['fields'][$opt_name]) && isset($ss_data['fields'][$opt_name]['def'])) {
				return $ss_data['fields'][$opt_name]['def'];	
			}	
		}
	}
	
	return false;
}



// given a settings field name, returns its value with default value fallback
function fr_opt_to_val($opt_name, $unit = false, $int_to_float = false, $echo = true) {
	
	$val = get_option($opt_name, fr_opt_to_def_val($opt_name));
	$val = (!empty($val) && $int_to_float) ? ((int)$val / 100) : $val;
	$val = ($unit) ? $val.$unit : $val;
	
	if($echo) {
		echo $val;	
	} else {
		return $val;	
	}
}



// use gzcompress to compress a string (where available)
function fr_maybe_compress($string) {
	return (function_exists('gzcompress') && function_exists('gzuncompress')) ? 'fr_gzc_'. base64_encode(gzcompress((string)$string, 9)) : (string)$string;
}


// use gzcompress to uncompress a string (where available)
function fr_maybe_uncompress($string) {
	return (substr($string, 0, 7) == 'fr_gzc_' && function_exists('gzcompress') && function_exists('gzuncompress')) ? 
		stripslashes(gzuncompress(base64_decode(str_replace('fr_gzc_', '', $string)))) : 
		(string)$string;
}



// WPML & Polylang integration - given a page ID, searches a translation. If not found, return original value
function fr_wpml_translated_pag_id($obj_id, $post_type = 'page'){
	
	// WPML
	if(function_exists('icl_object_id')) {
		$trans_val = icl_object_id($obj_id, $post_type, true);
		if($trans_val && get_post_status($trans_val) == 'publish') {
			return $trans_val;
		}
	} 	
	
	// polylang
	if(function_exists('pll_get_post')) {
		$trans_val = pll_get_post($obj_id);
		if($trans_val && get_post_status($trans_val) == 'publish') {
			return $trans_val;
		}
	} 	
	
	return $obj_id;
}
