(function(){
    "use strict";
	
	// creates plugin
	tinymce.PluginManager.add('FAQRevo', function( editor, url ) {

        // Add a button that opens a window
        editor.addButton('fr_btn', {
            text		: false,
			title		: 'FAQ Revolution',
            icon		: 'fr_btn',  // css class  mce-i-fr_btn
            onclick		: function() {

				jQuery.magnificPopup.open({
					items : {
						src: '#fr-shortcode-form > *',
						type: 'inline'
					},
					mainClass	: 'fr_magpop fr_sc_wizard_lb',
					closeOnContentClick	: false,
					closeOnBgClick		: false, 
					preloader	: false,
					callbacks	: {
					  beforeOpen: function() {
						if(jQuery(window).width() < 800) {
						  this.st.focus = false;
						}
					  },
					  open : function() {
                        new lc_select('.fr_scw_wrap select[name="fr_sc_excl_subj"]', {
                            wrap_width : '100%',
                            addit_classes : ['lcslt-lcwp', 'lcslt-lcwp-tinymce-lb'],
                        });      
                          
						lc_switch('.fr_scw_wrap input[name="fr_sc_req_src"]', {
                            on_txt      : 'yes',
                            off_txt     : 'no',   
                        });
					  }
					}
				});
				jQuery(document).on('click', '.mfp-wrap.fr_sc_wizard_lb', function(e) {
					if(jQuery(e.target).hasClass('mfp-container')) {
						jQuery.magnificPopup.close();
					}
				});
            }

        });
	});
	
	
	
	
	////////////////////////////////////////////////////////
	///// insert shortcode
	jQuery(document).on('click', '.fr_magpop [name=fr_sc_insert]', function() {	
		
		var sc	= '[faq-revo-searchbar',
			$lb	= jQuery('.fr_magpop');
		
		// subject
		if($lb.find('[name=fr_sc_subj]').val()) {
			sc += ' subj="'+ $lb.find('[name=fr_sc_subj]').val() +'"';	
		
			// child subject
			if($lb.find('[name=fr_sc_sub_subj]').length && $lb.find('[name=fr_sc_sub_subj]').val()) {
				sc += ' sub_subj="'+ $lb.find('[name=fr_sc_sub_subj]').val() +'"';	
			}
		}
		
		// require search
		if($lb.find('[name=fr_sc_req_src]').is(':checked')) {
			sc += ' req_src="1"';		
		}

        // excluded subjs
        if($lb.find('select[name="fr_sc_excl_subj"]').val().length) {
            sc += ' excl_subj="'+ $lb.find('select[name="fr_sc_excl_subj"]').val().join(',') +'"';        
        }
        
		tinyMCE.activeEditor.execCommand('mceInsertContent', 0, sc +']');
		jQuery.magnificPopup.close();
	});
	
})();
