<?php 


// colors reset button
function fr_colors_reset_btn($field_id, $field, $value, $all_vals) {
	?>
	<style type="text/css">
	#colors_reset.lcwp_settings_sect_title {
		display: none;	
	}
	#fr_reset_colors {
		padding: 4px 13px 4px 10px;
		height: auto;
		margin-top: 35px;	
	}
	#fr_reset_colors span {
		line-height: 27px;
	}
	#fr_reset_colors strong {
		font-size: 15px;
		line-height: normal;
	}
	</style>
	
	<button id="fr_reset_colors" class="button-secondary">
		<span class="dashicons dashicons-backup"></span> 
		<strong><?php echo esc_attr(__('Reset Colors', 'fr_ml')) ?></strong>
	</button>
        
	<?php
	// create defaults array to be managed by javascript
	$defs = array();
	foreach($GLOBALS['fr_settings_structure']['colors'] as $sect_id => $sect_data) {
	
		foreach($sect_data['fields'] as $f_id => $f_data) {
			if(isset($f_data['def'])) {
				
				$defs[$f_id] = $f_data['def']; 
			}
		}	
	}
	?>
    <script type="text/javascript">
	jQuery(document).ready(function($) {
        var defs = $.parseJSON("<?php echo addslashes(json_encode($defs)) ?>");
		
		jQuery(document).on('click', '#fr_reset_colors', function(e) {
			e.preventDefault();
			
			if(confirm("<?php echo esc_attr(__('Reset colors to their default values?', 'fr_ml')) ?>")) {
				
				$.each(defs, function(f_id, val) {
					$('input[name="'+ f_id +'"]').val(val).trigger('keyup');
				});
			}
		});
    });
	</script>
	<?php
}