<?php 
include_once(FR_DIR . '/settings/field_options.php'); 
$ml_key = 'fr_ml';



// MG-FILTER - manipulate settings tabs
$tabs = array(
	'main_opts' 	=> __('Main Options', $ml_key),
	'styling' 		=> __('Styling', $ml_key),
	'colors' 		=> __('Colors', $ml_key),
	'cust_css'		=> __('Custom CSS', $ml_key),
);
$GLOBALS['fr_settings_tabs'] = apply_filters('fr_settings_tabs', $tabs);	



$wp_pag_templates = (function_exists('get_page_templates')) ? array_flip(get_page_templates()) : array();



// STRUCTURE
/* tabs index => array( 
	'sect_id' => array(
		'sect_name'	=> name
		'fields'	=> array(
			...
		)
	)
   )
*/

$structure = array();


####################################
########## MAIN OPTIONS ############
####################################
$structure['main_opts'] = array(
	
	'faq_behaviors' => array(
		'sect_name'	=>  __('FAQ Parameters', $ml_key),
		'fields' 	=> array(
			
			'fr_subj_dd_ph' => array(
				'label' 	=> __('Subjects dropdown placeholder', $ml_key),
				'type'		=> 'text',
				'def' 		=> __('Select a subject', $ml_key),
				'required' 	=> true,
				'note'		=> __("Set which phrase to show by default on sections dropdown", $ml_key)
			),
			'fr_any_sub_subj_txt' => array(
				'label' 	=> __('Any FAQs "child subject" text', $ml_key),
				'type'		=> 'text',
				'def' 		=> __('Any section', $ml_key),
				'required' 	=> true,
				'note'		=> __("This text represents the default choice in child subjects dropdown (eg. Any section)", $ml_key)
			),
			'fr_searchbar_ph' => array(
				'label' 	=> __("Searchbar placeholder", $ml_key),
				'type'		=> 'text',
				'def' 		=> __('Describe your problem', $ml_key) .' ..',
				'note'		=> __("Text shown by default in the FAQ searchbar", $ml_key)
			), 
			'fr_kb_legend' => array(
				'label' 	=> __("FAQ's related knowledge-base legend", $ml_key),
				'type'		=> 'text',
				'def' 		=> __('Related articles', $ml_key),
				'required' 	=> true,
				'note'		=> __("Text shown above knowledge-base links list", $ml_key)
			), 
			'fr_nores_txt' => array(
				'label' 	=> __('"no result" text', $ml_key),
				'type'		=> 'wp_editor',
				'rows' 		=> 2,
				'required' 	=> true,
				'def' 		=> __('No FAQs found', $ml_key) .' ..',
				'note'		=> __("Text shown if no FAQ matches what is written in the searchbar", $ml_key)
			), 
			'fr_faq_search_pag' => array(
				'label' 	=> __("Main FAQs search pages", $ml_key),
				'type'		=> 'select',
				'multiple'	=> true,
				'fullwidth'	=> true,
				'val' 		=> fr_pages_list(),
				'note'		=> __('Choose which pages will have deeplink system enabled in these pages.<br/>
								<font style="color: #D54E21;"><strong>NB:</strong></font> you can only use one search box for each of these pages!', $ml_key), 
			),  
		),
	),
	
	
	'faq_fixed_ends' => array(
		'sect_name'	=>  __('FAQs - Fixed Ends Texts', $ml_key),
		'fields' 	=> array(
				
			'fr_solution_case' => array(
				'label' 	=> __('"solution" case text', $ml_key),
				'type'		=> 'wp_editor',
				'rows' 		=> 4,
				'required' 	=> true,
				'def'		=> __('Doing what described you should have solved your problem.<br/>If it persists, please contact the site administrator <a href="#">at this link</a>', $ml_key),
			),  
			'fr_user_act_case' => array(
				'label' 	=> __('"user action" case text', $ml_key),
				'type'		=> 'wp_editor',
				'rows' 		=> 4,
				'required' 	=> true,
				'def'		=> __('It seems that your problem needs to be checked directly.<br/>Please contact the site administrator <a href="#">at this link</a>', $ml_key),
			),  
		),
	),
	
	
	'rating_sys' => array(
		'sect_name'	=>  __('Rating System', $ml_key),
		'fields' 	=> array(
			
			'fr_use_rating' => array(
				'label' => __('Enable rating system?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, an evaluation box will be appended to final FAQ answers", $ml_key),
			), 
			'fr_rating_legend' => array(
				'label' 	=> __("Which text to show above rating icons?", $ml_key),
				'type'		=> 'text',
				'def' 		=> __('Was this helpful?', $ml_key),
				'required' 	=> true,
			), 
			'fr_compact_rating' => array(
				'label' => __('Compact rating layout?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, rating system will be displayed on a unique line", $ml_key),
			), 
		),
	),	
	
	
	'kb_tags' => array(
		'sect_name'	=>  __('Knowledge-base Tags', $ml_key),
		'fields' 	=> array(
			
			'fr_public_kb_tags' => array(
				'label' => __('Show tags in KB articles?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, article tags will be appended to the text and tag archives will be accessible", $ml_key),
			),
			'fr_kb_tags_layout' => array(
				'label' 	=> __('Tags layout', $ml_key),
				'type'		=> 'select',
				'val' 		=> array(
					'links' 	=> __('Links', $ml_key), 
					'buttons' 	=> __('Buttons', $ml_key),
				), 
			),   
			'fr_kb_tags_legend' => array(
				'label' 	=> __("Tags legend", $ml_key),
				'type'		=> 'text',
				'def' 		=> '<span class="dashicons dashicons-tag"></span> Tags:',
				'maxlen'	=> 150,
				'required' 	=> true,
				'fullwidth'	=> true,
				'note'		=> __("Defines which text is printed before tags list. You can use <a href='https://developer.wordpress.org/resource/dashicons/' target='_blank'>dashicons codes</a>", $ml_key),
			), 
		),
	),
	
	
	
	'wp_pag_templates' => array(
		'sect_name'	=>  __('Page Templates', $ml_key),
		'fields' 	=> array(
			
			'fr_faq_pag_template' => array(
				'label' 	=> __('FAQs page template', $ml_key),
				'type'		=> 'select',
				'val' 		=> array('page.php' => '('. __('default one', $ml_key) .')') + $wp_pag_templates, 
				'note'		=> __("Choose which page template assign to FAQs page", $ml_key) 
			),   
			'fr_kb_pag_template' => array(
				'label' 	=> __('Knowledge-base page template', $ml_key),
				'type'		=> 'select',
				'val' 		=> array('page.php' => '('. __('default one', $ml_key) .')') + $wp_pag_templates,  
				'note'		=> __("Choose which page template assign to KB articles", $ml_key) 
			),   
		),
	),	
	
	
	
	'permalinks' => array(
		'sect_name'	=>  __('Permalinks', $ml_key),
		'fields' 	=> array(
			
			'fr_faq_baseurl' => array(
				'label' 	=> __("FAQs base-url", $ml_key),
				'type'		=> 'text',
				'def' 		=> 'faq',
				'maxlen'	=> 40,
				'regex'		=> '/^[a-z_-]+$/',
				'required' 	=> true,
				'note'		=> "<font style='color: #D54E21;'>". __("Only lowercase characters, hyphens and underscores allowed.", $ml_key) .'</font><br/>'.
								 __("URL structure example", $ml_key) ." <font style='color: #555;'>".home_url()."/base-url/the-faq-title</font>",
			), 
			'fr_kb_baseurl' => array(
				'label' 	=> __("Knowledge Base base-url", $ml_key),
				'type'		=> 'text',
				'def' 		=> 'kb',
				'maxlen'	=> 40,
				'regex'		=> '/^[a-z_-]+$/',
				'required' 	=> true,
				'note'		=> "<font style='color: #D54E21;'>". __("Only lowercase characters, hyphens and underscores allowed.", $ml_key) .'</font><br/>'.
								 __("URL structure example", $ml_key) ." <font style='color: #555;'>".home_url()."/base-url/the-article-slug</font>",
			), 
			'fr_kb_tags_baseurl' => array(
				'label' 	=> __("Knowledge Base tags base-url", $ml_key),
				'type'		=> 'text',
				'def' 		=> 'kb-tags',
				'maxlen'	=> 40,
				'regex'		=> '/^[a-z_-]+$/',
				'required' 	=> true,
				'note'		=> "<font style='color: #D54E21;'>". __("Only lowercase characters, hyphens and underscores allowed.", $ml_key) .'</font><br/>'.
								 __("URL structure example", $ml_key) ." <font style='color: #555;'>".home_url()."/base-url/the-tag-slug</font>",
			), 
		),
	),	

		
	'advanced' => array(
		'sect_name'	=>  __('Advanced', $ml_key),
		'fields' 	=> array(
			  
            'fr_use_gutenberg' => array(
				'label' => __('Enable WP Gutenberg editor?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, enables Gutenberg editor for FAQs and Knowledge Base posts", $ml_key),
			),
            'fr_default_sorting' => array(
				'label' 	=> __('Default FAQ Subjects and FAQs sorting order', $ml_key),
				'type'		=> 'select',
				'val' 		=> array(
					'name_asc' => __('Name (ascending)', $ml_key),
					'name_desc'=> __('Name (descending)', $ml_key),
					'id_asc' => __('Date added (ascending)', $ml_key),
					'id_desc'=> __('Date added (decending)', $ml_key),
				),
				'note'		=> '',
			),
            'fr_subj_deepl_type' => array(
				'label' 	=> __('Which data to use to compose subject deeplinks?', $ml_key),
				'type'		=> 'select',
				'val' 		=> array(
					'slug' 		=> __('Slug', $ml_key), 
					'id_name' 	=> __('ID + Name', $ml_key),
					'slug_name' => __('Slug + Name', $ml_key),
					'none' 		=> __('No Deeplink', $ml_key),
				),
				'note'		=> __("Set how to manage deeplinks in FAQ search page", $ml_key) 
			),
			'fr_no_sub_subjs' => array(
				'label' => __('Use only first-level subjects?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, child subjects will be hidden and disabled from deeplinking", $ml_key),
			), 
			'fr_only_faq_pag' => array(
				'label' => __('Always open FAQ page clicking on search results?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, matched FAQs will open their respective page instead of being recalled in a frame.<br/>Is useful to increase pageviews", $ml_key),
			),  
			'fr_inline_css' => array(
				'label' => __('Use custom CSS inline?', $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, uses custom CSS inline <strong>(useful for multisite installations)</strong>", $ml_key),
			), 
			'fr_js_head' => array(
				'label' => __("Use javascript in website's head?", $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("<strong>Check it ONLY IF you notice some incompatibilities</strong>", $ml_key),
			),     
		),
	),
);	
	



// WOOCOMMERCE INTEGRATION
if(!function_exists('is_plugin_active')) {
    include_once(ABSPATH .'wp-admin/includes/plugin.php');
}
if(is_plugin_active('woocommerce/woocommerce.php')) {
    include_once(FR_DIR .'/settings/settings_engine.php'); 
    
    $to_inject = array(
        
        'woocomm_integration' => array(
            'sect_name'	=>  __('WooCommerce Product Tabs Integration', $ml_key),
            'fields' 	=> array(

                'fr_wc_tab_title' => array(
                    'label' 	=> __("Tab title", $ml_key),
                    'type'		=> 'text',
                    'def' 		=> 'FAQ',
                    'maxlen'	=> 200,
                    'fullwidth' => true,
                    'required' 	=> true,
                ),   
                'fr_wc_tab_priority' => array(
                    'label' 	=> __("Tab priority", $ml_key),
                    'type'		=> 'slider',
                    'min_val'	=> 0,
                    'max_val'	=> 300,	
                    'step'		=> 1,
                    'def'		=> 80,
                    'value'		=> '',
                    'respect_limits' => true,
                    'required'	=> true,
                    'note'		=> __("Defines tab's position when injected (eg. using a low value it will be injected before others)", $ml_key),
                ), 
                'fr_wc_tab_pre_txt' => array(
                    'label' 	=> __('Pre-FAQ text (optional)', $ml_key),
                    'type'		=> 'wp_editor',
                    'rows' 		=> 2,
                    'def' 		=> '',
                ), 
                'fr_wc_tab_def_status' => array(
                    'label' => __('Enable it on every product by default?', $ml_key),
                    'type'	=> 'checkbox',
                    'note'	=> __("You will be able to change this option in each product's editor", $ml_key),
                ),  
                'fr_wc_tab_def_subj' => array(
                    'label' 	=> __('Default subject used for FAQ box', $ml_key),
                    'type'		=> 'select',
                    'val' 		=> array('' => '('. __('none', $ml_key) .')') + fr_sub_subsubjs_for_builders(),
                    'note'		=> __("You will be able to change this option in each product's editor", $ml_key),
                ),   
            ),
        )
    );
    
    $structure['main_opts'] = lcwp_settings_engine::inject_array_elem($to_inject, $structure['main_opts'], 'permalinks', 'before');
}



		
	

####################################
############ STYLING ###############
####################################
$structure['styling'] = array(
	
	'wrap_max_w' => array(
		'sect_name'	=>  __('Elements max-width', $ml_key),
		'fields' 	=> array(
			
			'fr_wrap_max_w' => array(
				'label' 	=> __("Elements max-width", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 200,
				'max_val'	=> 2000,	
				'step'		=> 20,
				'def'		=> 2000,
				'value'		=> 'px',
                'respect_limits' => true,
				'required'	=> true,
				'note'		=> __("Force FAQs search and FAQ contents to have a maximum width. <br/>
									<strong>Use 2000 to disable this system</strong>", $ml_key),
			), 
			'fr_center_wrap' => array(
				'label' => __("Center align elements?", $ml_key),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, elements will be centered in wider wrappers", $ml_key),
			),     
		),
	),		


	'typography' => array(
		'sect_name'	=>  __('Typography', $ml_key),
		'fields' 	=> array(
			
			'fr_main_font_size' => array(
				'label' 	=> __("Wrapper's font size (on desktop)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 5,
				'max_val'	=> 30,	
				'step'		=> 1,
				'def'		=> 16,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("This value will be used as reference by plugin elements", $ml_key),
			), 
			'fr_mobile_font_size' => array(
				'label' 	=> __("Wrapper's font size (on mobile)", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 5,
				'max_val'	=> 30,	
				'step'		=> 1,
				'def'		=> 14,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
			), 
			'spcr1' => array(
				'type' => 'spacer',
			),
			
			
			'fr_dd_sel_font_size' => array(
				'label' 	=> __('Dropdowns selected value - font size', $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 50,
				'max_val'	=> 250,	
				'step'		=> 5,
				'def'		=> 120,
				'value'		=> '%',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Percentage value is related to website's font size. 100% = same size", $ml_key),
			), 
			'fr_dd_opt_font_size' => array(
				'label' 	=> __('Dropdown options - font size', $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 50,
				'max_val'	=> 250,	
				'step'		=> 5,
				'def'		=> 110,
				'value'		=> '%',
                'respect_limits' => false,
				'required'	=> true,
			), 
			'fr_faqs_list_font_size' => array(
				'label' 	=> __('Found FAQs list - font size', $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 50,
				'max_val'	=> 250,	
				'step'		=> 5,
				'def'		=> 120,
				'value'		=> '%',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Applied to FAQs found in the search context", $ml_key),
			), 
			'spcr2' => array(
				'type' => 'spacer',
			),
			
			'fr_faq_title_font_size' => array(
				'label' 	=> __("FAQ's title - font size", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 50,
				'max_val'	=> 250,	
				'step'		=> 5,
				'def'		=> 140,
				'value'		=> '%',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Only applied in FAQ search context", $ml_key),
			), 
			'fr_faq_title_font_family' => array(
				'label' 	=> __("FAQ's title - font family", $ml_key),
				'type'		=> 'text',
				'note'		=> __("Sets a custom font family for FAQ titles in FAQ search context. Leave empty to use the default one", $ml_key),
			), 
			'fr_faq_txt_font_size' => array(
				'label' 	=> __("FAQ's text - font size", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 50,
				'max_val'	=> 250,	
				'step'		=> 5,
				'def'		=> 100,
				'value'		=> '%',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("Only applied in FAQ search context", $ml_key),
			),
			'fr_faq_questions_font_size' => array(
				'label' 	=> __("FAQ questions - font size", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 50,
				'max_val'	=> 250,	
				'step'		=> 5,
				'def'		=> 110,
				'value'		=> '%',
                'respect_limits' => false,
				'required'	=> true,
			), 
		),
	),
	
	
	'dd_img_sizes' => array(
		'sect_name'	=>  __('Dropdown Option Images', $ml_key),
		'fields' 	=> array(
			
			'fr_dd_img_sizes' => array(
				'label' 	=> __("Image sizes (on desktop)", $ml_key),
				'type'		=> '2_numbers',
				'min_val'	=> 10,
				'max_val'	=> 200,	
				'value'		=> 'px',
				'def'		=> array(40, 40),
				'note'		=> __("width | height", $ml_key),
			),  
			'fr_dd_img_sizes_mob' => array(
				'label' 	=> __("Image sizes (on mobile)", $ml_key),
				'type'		=> '2_numbers',
				'min_val'	=> 10,
				'max_val'	=> 150,	
				'value'		=> 'px',
				'def'		=> array(20, 20),
				'note'		=> __("width | height", $ml_key),
			),  
			'fr_dd_img_radius' => array(
				'label' 	=> __("Images border radius", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 50,	
				'step'		=> 1,
				'def'		=> 1,
                'respect_limits' => true,
				'value'		=> '%',
				'required'	=> true,
				'note'		=> __("0% = squared design. 50% = round image", $ml_key),
			), 
		),
	),
	
	
	'faq_img' => array(
		'sect_name'	=>  __('FAQ Images', $ml_key),
		'fields' 	=> array(
			
			'fr_faq_img_h' => array(
				'label' 	=> __("Images height", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 30,
				'max_val'	=> 300,	
				'step'		=> 10,
				'def'		=> 100,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
				'note'		=> __("<strong>FYI:</strong> this value might be slightly increased by the justifier script to avoid excessive crops", $ml_key),
			), 
			'fr_faq_img_overlay' => array(
				'label' => __('Display images overlay?', $ml_key),
				'type'	=> 'checkbox',
				'def'	=> 1,
				'note'	=> __('If checked, an overlay will be shown over FAQ images', $ml_key),
			),  
		),
	),
	
	
	'elem_border_style' => array(
		'sect_name'	=>  __('Elements Border', $ml_key),
		'fields' 	=> array(
			
			'fr_dd_border_size' => array(
				'label' 	=> __("Dropdowns and searchbar border size", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 10,	
				'step'		=> 1,
				'def'		=> 2,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
			), 
			'fr_dd_border_style' => array(
				'label' 	=> __('Dropdowns and searchbar border style', $ml_key),
				'type'		=> 'select',
				'val' 		=> fr_border_styles(),
				'def'		=> 'solid',
			),  
			'spcr1' => array(
				'type' => 'spacer',
			),
			
			'fr_faqs_list_border_size' => array(
				'label' 	=> __("FAQs list element border size", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 10,	
				'step'		=> 1,
				'def'		=> 0,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
			), 
			'fr_faqs_list_border_style' => array(
				'label' 	=> __('FAQs list element border style', $ml_key),
				'type'		=> 'select',
				'val' 		=> fr_border_styles(),
				'def'		=> 'solid',
			),  
			'spcr2' => array(
				'type' => 'spacer',
			),
			
			'fr_faq_border_size' => array(
				'label' 	=> __("FAQ contents border size", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 10,	
				'step'		=> 1,
				'def'		=> 0,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
			), 
			'fr_faq_border_style' => array(
				'label' 	=> __('FAQ contents border style', $ml_key),
				'type'		=> 'select',
				'val' 		=> fr_border_styles(),
				'def'		=> 'solid',
			),  
			'spcr3' => array(
				'type' => 'spacer',
			),
			
			'fr_sep_border_size' => array(
				'label' 	=> __("FAQ sections separator size", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 10,	
				'step'		=> 1,
				'def'		=> 2,
				'value'		=> 'px',
                'respect_limits' => false,
				'required'	=> true,
			), 
			'fr_sep_border_style' => array(
				'label' 	=> __('FAQ sections separator style', $ml_key),
				'type'		=> 'select',
				'val' 		=> fr_border_styles(),
				'def'		=> 'dashed',
			),  
		),
	),
	
	
	'elem_border_radius' => array(
		'sect_name'	=>  __('Border Radius', $ml_key),
		'fields' 	=> array(
			
			'fr_elem_radius' => array(
				'label' 	=> __("Elements border radius", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 40,	
				'step'		=> 1,
				'def'		=> 2,
				'value'		=> 'px',
                'respect_limits' => true,
				'required'	=> true,
				'note'		=> __("Use zero for a squared design and 40 to have rounded edges", $ml_key),
			), 
			'fr_dd_img_radius' => array(
				'label' 	=> __("Dropdown images border radius", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 50,	
				'step'		=> 1,
				'def'		=> 5,
				'value'		=> '%',
                'respect_limits' => true,
				'required'	=> true,
				'note'		=> __("Use zero for a squared design and 50 to have a circle", $ml_key),
			), 
		),
	),
	
);



####################################
########### COLORS #################
####################################	

$ds_txt = ' '. __('(default state)', $ml_key);
$hs_txt = ' '. __('(hover state)', $ml_key);

	
$structure['colors'] = array(		
	'colors_reset' => array(
		'sect_name'	=>  __('Colors Reset', $ml_key),
		'fields' 	=> array(
			  
			'fr_colors_reset' => array(
				'type'		=> 'custom',
				'callback'	=> 'fr_colors_reset_btn',
			), 
		),
	),
	
	
	'dd_colors' => array(
		'sect_name'	=>  __('Dropdown And Searchbar Colors', $ml_key),
		'fields' 	=> array(
		
			'fr_dd_txt_col' => array(
				'label' => __('Text color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => false,
				'def'	=> '#5a5a5a',
			),
			'fr_dd_bg_col' => array(
				'label' => __('Background color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#ffffff',
			),
			'fr_dd_border_col' => array(
				'label' => __('Border color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#e0e0e0',
			),
			'spcr1' => array(
				'type' => 'spacer',
			),
			
			'fr_dd_txt_col_h' => array(
				'label' => __('Text color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => false,
				'def'	=> '#505050',
			),
			'fr_dd_bg_col_h' => array(
				'label' => __('Background color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#ffffff',
			),
			'fr_dd_border_col_h' => array(
				'label' => __('Border color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#cccccc',
			),
		),
	),
	
	
	'faq_list_colors' => array(
		'sect_name'	=>  __('FAQs List Colors', $ml_key),
		'fields' 	=> array(
		
			'fr_faqs_list_txt_col' => array(
				'label' => __('Text color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => false,
				'def'	=> '#505050',
			),
			'fr_faqs_list_bg_col' => array(
				'label' => __('Background color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#efefef',
			),
			'fr_faqs_list_border_col' => array(
				'label' => __('Border color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#dfdfdf',
			),
			'spcr1' => array(
				'type' => 'spacer',
			),
			
			'fr_faqs_list_txt_col_h' => array(
				'label' => __('Text color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => false,
				'def'	=> '#3e3e3e',
			),
			'fr_faqs_list_bg_col_h' => array(
				'label' => __('Background color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#f3f3f3',
			),
			'fr_faqs_list_border_col_h' => array(
				'label' => __('Border color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#efefef',
			),
		),
	),
	
	
	'chosen_faq_colors' => array(
		'sect_name'	=>  __('Chosen FAQ Colors (in search context)', $ml_key),
		'fields' 	=> array(
		
			'fr_loader_col' => array(
				'label' => __('Preloader color', $ml_key),
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#bbbbbb',
			),
			'spcr1' => array(
				'type' => 'spacer',
			),
			
			'fr_faqs_txt_col' => array(
				'label' => __('Text color', $ml_key),
				'type'	=> 'color',
                'extra_modes' => false,
				'def'	=> '#505050',
			),
			'fr_faqs_bg_col' => array(
				'label' => __('Background color', $ml_key),
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#efefef',
			),
			'fr_faqs_border_col' => array(
				'label' => __('Border color', $ml_key),
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#dfdfdf',
			),
			'spcr2' => array(
				'type' => 'spacer',
			),
			
			'fr_faqs_link_col' => array(
				'label' => __('Links color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => false,
				'def'	=> '#444444',
			),
			'fr_faqs_link_col_h' => array(
				'label' => __('Links color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => false,
				'def'	=> '#303030',
			),
			'spcr2' => array(
				'type' => 'spacer',
			),
			
			'fr_faq_sep_border_col' => array(
				'label' => __('FAQ sections separator', $ml_key),
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#cccccc',
				'note'	=> __("Applied also in standalone FAQ page", $ml_key),
			),
		),
	),
	
	
	'btf_colors' => array(
		'sect_name'	=>  __('"Back to FAQs list" Button Colors (in search context)', $ml_key),
		'fields' 	=> array(
		
			'fr_btfl_col' => array(
				'label' => __('Icon color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#ffffff',
			),
			'fr_btfl_bg' => array(
				'label' => __('Background color', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#cacaca',
			),
			'spcr1' => array(
				'type' => 'spacer',
			),
			
			'fr_btfl_col_h' => array(
				'label' => __('Icon color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#ffffff',
			),
			'fr_btfl_bg_h' => array(
				'label' => __('Background color', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#aaaaaa',
			),
		),
	),
	
	
	'img_ol_colors' => array(
		'sect_name'	=>  __('Images Overlay Colors', $ml_key),
		'fields' 	=> array(
		
			'fr_img_ol_icon' => array(
				'label' => __('Icon', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#ffffff',
			),
			'fr_img_ol_bg' => array(
				'label' => __('Background', $ml_key) . $ds_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#111111',
			),
			'fr_img_ol_bg_opacity' => array(
				'label' 	=> __("Background's opacity", $ml_key) . $ds_txt,
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 100,	
				'step'		=> 5,
				'def'		=> 0,
				'value'		=> '%',
                'respect_limits' => true,
				'required'	=> true,
			), 
			'spcr1' => array(
				'type' => 'spacer',
			),
			
			'fr_img_ol_icon_h' => array(
				'label' => __('Icon', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#ffffff',
			),
			'fr_img_ol_bg_h' => array(
				'label' => __('Background', $ml_key) . $hs_txt,
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#111111',
			),
			'fr_img_ol_bg_opacity_h' => array(
				'label' 	=> __("Background's opacity", $ml_key) . $hs_txt,
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 100,	
				'step'		=> 5,
				'def'		=> 25,
				'value'		=> '%',
                'respect_limits' => true,
				'required'	=> true,
			), 
		),
	),
	
	
	'lightbox_colors' => array(
		'sect_name'	=>  __('Lightbox Colors', $ml_key),
		'fields' 	=> array(
		
			'fr_lb_icons' => array(
				'label' => __('Icons', $ml_key),
				'type'	=> 'color',
                'extra_modes' => array('alpha'),
				'def'	=> '#ffffff',
			),
			'fr_lb_ol_bg' => array(
				'label' => __('Background', $ml_key),
				'type'	=> 'color',
                'extra_modes' => array('alpha', 'linear-gradient', 'radial-gradient'),
				'def'	=> '#111111',
			),
			'fr_lb_ol_bg_opacity' => array(
				'label' 	=> __("Background's opacity", $ml_key),
				'type'		=> 'slider',
				'min_val'	=> 0,
				'max_val'	=> 100,	
				'step'		=> 5,
				'def'		=> 70,
				'value'		=> '%',
                'respect_limits' => true,
				'required'	=> true,
			), 
		),
	),
);




####################################
########### CUSTOM CSS #############
####################################		
$structure['cust_css'] = array(	
	'custom_css_wrap' => array(
		'sect_name'	=>  __('High-priority code - applied to plugin elements', $ml_key),
		'fields' 	=> array(
		
			'fr_custom_css' => array(
				'label' 	=> __('Custom CSS', $ml_key),
				'type'		=> 'code_editor',
				'language'	=> 'css',
			),
		),
	),
);





// MG-FILTER - manipulate settings structure
$GLOBALS['fr_settings_structure'] = apply_filters('fr_settings_structure', $structure);
