<?php 
dike_lc('lcweb', 'fr', true);
$ml_key = 'fr_ml';


// framework engine
include_once(FR_DIR .'/classes/simple_form_validator.php');
include_once(FR_DIR .'/settings/settings_engine.php'); 
include_once(FR_DIR .'/settings/field_options.php'); 
include_once(FR_DIR .'/settings/custom_fields.php');
include_once(FR_DIR .'/settings/structure.php'); 

lcwp_settings_engine::$prod_acronym = 'lcfr';
lcwp_settings_engine::$css_prefix = 'fr_';
lcwp_settings_engine::$ml_key = 'fr_ml';

$engine = new lcwp_settings_engine('fr_settings', $GLOBALS['fr_settings_tabs'], $GLOBALS['fr_settings_structure']);
?>

<div class="wrap lcwp_settings_wrap">  
    <div class="lcwp_settings_head">
        <h2><?php esc_html_e('FAQ Revolution Settings', $ml_key) ?></h2>  
        
        <div>
            <?php echo $engine->import_export_btns() ?>
            <form class="lcwp_sf_search_wrap">
                <i class="dashicons dashicons-no-alt"></i>
                <input type="text" name="lcwp_sf_search" value="" placeholder="<?php esc_attr_e('search fields', $ml_key) ?> .." /> 
            </form>
        </div>
    </div>
    
	<?php
    // get fetched data and allow customizations
    if($engine->form_submitted()) {
        $fdata = $engine->form_data;
        $errors = (!empty($engine->errors)) ? $engine->errors : array();


		///////////////
		
		
		///////////////


        // FR-FILTER - manipulate setting errors - passes errors array and form values - error subject as index + error text as val
        $errors = apply_filters('fr_setting_errors', $errors, $fdata);	
        
        
        // save or print error
        if(empty($errors)) {
            
            // FR-FILTER - allow data manipulation (or custom actions) before settings save - passes form values
            $engine->form_data = apply_filters('fr_before_save_settings', $fdata); 
            
            
            // save
            $engine->save_data();
			
			
			///////////////
			
			// flush rewrite rules to track base-url changes
			flush_rewrite_rules();
			
			
			 // create custom style css file
          	if(!get_option('fr_inline_css')) {
				if(!fr_create_dynamic_css()) {
					echo '<div class="updated"><p>'. esc_html__('An error occurred during dynamic CSS creation. The code will be used inline anyway', $ml_key) .'</p></div>';
				}
				else {
                    delete_option('fr_inline_css');
                }
			}		   
			
			
			$engine->successful_save_redirect();
        }
        
        // compose and return errors
        else {
            echo $engine->get_error_message_html($errors);
        }
    }
	
	
	// if successdully saved
	echo $engine->get_success_message_html();
	
	// print form code
    echo $engine->get_code();
    ?>
</div>



<?php // CUSTOM CSS ?>
<style type="text/css">
#item_atts_wrap {
	display: none;	
}
</style>



<?php // SCRIPTS ?>
<script type="text/javascript">
(function($) { 
    "use strict";     
    
    <?php require_once(FR_DIR .'/settings/mandatory_js.php'); ?>
})(jQuery);  
</script>


<?php
// FR-ACTION - allow extra code printing in settings (for javascript/css)
do_action('fr_settings_extra_code');
?>
