<?php
// DISPLAYS FAQS SEARCHBAR

// [faq-revo-searchbar] 
function fr_searchbar_shortcode( $atts, $content = null ) {	
	global $wp;
	
	extract( shortcode_atts( array(
		
		'subj' 			=> '', // forced subject
		'sub_subj'		=> '', // forced sub-subject
		'req_src'		=> 0,  // whether to require search to show FAQs
        
        'excl_subj'     => '', // list of FAQ subjs (terms ID split by comma) to ignore in the list
		
		'subj_n_child' 	=> '', // builders fallback
	), $atts ));
    
	// builders fallback
	if(!empty($subj_n_child)) {
		list($subj, $sub_subj) = (strpos($subj_n_child, '|') === false) ? array('', '') : explode('|', $subj_n_child);	
	}
	
	$sc_subj       = $subj;
	$sc_sub_subj   = $sub_subj;
	
    $excl_subj     = array_unique(explode(',', str_replace('|', ',', $excl_subj)));
    $excl_subj     = array_values($excl_subj);
	
	// code init - form opening
	$fr_id = 'fr_'. uniqid();
	
	
	$code = '
	<form id="'. $fr_id .'" action="post" target="" class="fr_searchbar_form" data-req-src="'. (int)$req_src .'">';

		$subjs = fr_get_subjs();

		// no subjects - stop here
		if(empty($subjs)) {
			return '';	
		}
				
		// retrieve deeplinked values
		$raw_dl_subj 		= (isset($wp->query_vars['fr_subj'])) 		? $wp->query_vars['fr_subj'] : ''; 
		$raw_dl_sub_subj 	= (isset($wp->query_vars['fr_sub_subj'])) 	? $wp->query_vars['fr_sub_subj'] : ''; 
		$raw_dl_faq 		= (isset($wp->query_vars['fr_faq'])) 		? $wp->query_vars['fr_faq'] : ''; 
		
		// forced subject by shortcode param
		if(!empty($sc_subj) && isset($subjs[$sc_subj])) {
			$arr_vals 		= $sc_subj;
			$sel_subj_data 	= $subjs[$sc_subj];
			$sel_subj_id 	= $sel_subj_data->term_id;
			
			$code .= '<input type="hidden" name="fr_faq_subj_dl" value="'. fr_term_data_to_dl($sel_subj_data) .'" />';
		}
		
		// only one subject - use hidden input
		else if(count($subjs) == 1) {
			$arr_vals 		= array_values($subjs);
			$sel_subj_data 	= array_shift($arr_vals);
			$sel_subj_id 	= $sel_subj_data->term_id;
			
			$code .= '<input type="hidden" name="fr_faq_subj_dl" value="'. fr_term_data_to_dl($sel_subj_data) .'" />';
		}
		
		else {
			$deepl_subj_id 	= fr_deepl_to_term_id($raw_dl_subj);
			$sel_subj_id 	= ($deepl_subj_id && isset($subjs[ $deepl_subj_id ])) ? $deepl_subj_id : false;
			$sel_subj_name	= ($sel_subj_id) ? fr_subj_name($subjs[ $sel_subj_id ]) : '<em>'. get_option('fr_subj_dd_ph') .' ..</em>'; 
			
			if(empty($sel_subj_id)) {
				$prior_subj_choice 	= true;	
			}
			
			$code .= '
			<input type="hidden" name="fr_faq_subj" value="'. $sel_subj_id .'" />
			
			<div class="fr_subjs_container fr_custom_dd">
				<section>'. $sel_subj_name .'</section>
				
				<ul class="fr_subjs_list fr_custom_dd_list">';
					
					foreach($subjs as $s_id => $s_data) {
						if(in_array($s_id, $excl_subj)) {
                            continue;    
                        }
                        
                        $sel = ($s_id == $sel_subj_id) ? 'class="fr_custom_dd_sel"' : '';
						$code .= '<li data-val="'. $s_id .'" data-dl="'. fr_term_data_to_dl($s_data) .'" '. $sel .'>'. fr_subj_name($s_data) .'</li>';
					}

			$code .= '
				</ul>
			</div>';
		}
		
		
		// sub-subjects?
		$sel_sub_subj = $raw_dl_sub_subj;
		if(!get_option('fr_no_sub_subjs')) {
			
			$sc_sub_subj_term_data = (empty($sc_sub_subj)) ? false : term_exists((int)$sc_sub_subj, 'fr_faq_subjs', (int)$sc_subj);
			
			// forced sub-subject via shortcode param
			if($sc_sub_subj_term_data) {
				$sel_sub_subj = $sc_sub_subj;
				$code .= '<input type="hidden" name="fr_forced_sub_subj" value="'. $sel_sub_subj .'" />';
			}
			else {
				$sel_sub_subj = fr_deepl_to_term_id($sel_sub_subj);		
	
				$code .= fr_sub_subjs_json($fr_id, $subjs).
				'<div class="fr_sub_subj_wrap"></div>';
			}
		}
		
		
		// FAQ search
		$search_vis = (isset($prior_subj_choice)) ? 'style="display: none;"' : '';
		$code .= '
		<div class="fr_faq_search" '. $search_vis .'>
            <i class="fr_clear_search dashicons dashicons-no-alt" title="'. esc_attr__('clear search', 'fr_ml') .'"></i>
			<input value="" placeholder="'. esc_attr(get_option('fr_searchbar_ph')) .'" autocomplete="off" type="text">
		</div>';
		
		
		// preload FAQs related to previous deeplinks and open the selected one
		if($raw_dl_faq && !$req_src) {
			$arr = explode('-', $raw_dl_faq);
			$sel_faq_status = get_post_status( (int)$arr[0]);
			$sel_faq_id = ($sel_faq_status && $sel_faq_status == 'publish') ? (int)$arr[0] : false;
		} else {
			$sel_faq_id = false;
		}
		
		$code .= '
		<div class="fr_matching_faqs">';

			if($sel_subj_id) {
				$match_against = ($sel_sub_subj && $sel_sub_subj != 'any') ? $sel_sub_subj : $sel_subj_id;
				$code .= fr_front_search_get_faqs($fr_id, $match_against, $req_src, $sel_faq_id, $excl_subj);	
			}
		
		$code .= '	
		</div>
	</form>';


	// deeplinked vars
	$code .= '
	<script type="text/javascript">
    (function() { 
        "use strict";
    
        fr_subj["'. $fr_id .'"] 	= '. (int)$sel_subj_id .'; 
        fr_sub_subj["'. $fr_id .'"] = '. (int)$sel_sub_subj .';
        fr_faq["'. $fr_id .'"] 		= '. (int)$sel_faq_id .';
        fr_excl_subj["'. $fr_id .'"]= \''. json_encode($excl_subj) .'\';

        const intval = setInterval(() => {
            if(typeof(jQuery) == "undefined" || typeof(fr_init_searchbox) == "undefined") {
                return true;
            }
            else {
                clearTimeout(intval);
                
                const $ = jQuery,
                      $fr_obj = $("#'. $fr_id .'"); 

                /* if is the FAQ search page - set the global fr_id variable */
                if(fr_is_faq_search_pag) {
                    window.fr_id = "'. $fr_id .'";	
                }

                /* if theres no subj nor sub-subj set the class to avoid margins */
                if(!$fr_obj.find(".fr_subjs_list").length && !$fr_obj.find(".fr_sub_subj_wrap").length) {
                    $fr_obj.find(".fr_searchbar_form").addClass("fr_only_faqs_list");	
                }

                /* on pages opening */
                if($fr_obj.find(".fr_faqs_list li").length === 1) {

                    /* if theres only one FAQ and no sub-subj is chosen - hide it */
                    if($fr_obj.find(".fr_sub_subj_wrap").length && (!fr_sub_subj["'. $fr_id .'"] || fr_sub_subj["'. $fr_id .'"] == "any")) {
                        $fr_obj.find(".fr_sub_subj_wrap").hide();	

                        /* if theres no subj nor sub-subj set the class to avoid margins */
                        if(!$fr_obj.find(".fr_subjs_list").length) {
                            $fr_obj.addClass("fr_only_faqs_list");	
                        }
                    }

                    /* open the FAQ */
                    if(!fr_faq["'. $fr_id .'"]) {
                        $(document).ready(function() {
                            setTimeout(function() {
                                $("#'. $fr_id .' .fr_faqs_list li").trigger("click");
                            }, 20);
                        });
                    }

                    /* hide back-to-faq since theres only one */
                    $fr_obj.addClass("fr_no_back_btn");
                }

                /* init */
                setTimeout(function() {
                    fr_init_searchbox("'. $fr_id .'");
                }, 10);
            }
        }, 50);
    })();    
	</script>';

	return str_replace(array("\r", "\n", "\t", "\v"), '', $code);
}
add_shortcode('faq-revo-searchbar', 'fr_searchbar_shortcode');
