<?php
// IMPLEMENTING TINYMCE LIGHTBOX
	
function fr_action_admin_init() {
	if( !current_user_can('edit_posts') && !current_user_can('edit_pages') )
		return;

	if(get_user_option('rich_editing') == 'true') {
		add_filter('mce_external_plugins', 'fr_filter_mce_plugin');
		add_filter('mce_buttons', 'fr_filter_mce_button');
	}
}
add_action('admin_init', 'fr_action_admin_init');

	
function fr_filter_mce_button( $buttons ) {
	array_push( $buttons, '|', 'fr_btn');
	return $buttons;
}

function fr_filter_mce_plugin( $plugins ) {
	$plugins['FAQRevo'] = FR_URL .'/js/tinymce_btn.js';
	return $plugins;
}




function fr_editor_btn_content() {

	if(strpos($_SERVER['REQUEST_URI'], 'post.php') === false && strpos($_SERVER['REQUEST_URI'], 'post-new.php') === false && !isset($GLOBALS['fr_tinymce_editor'])) {return false;}
	$subjs = fr_get_subjs();
	?>
    <script type="text/javascript">
	fr_sub_subjs_list = [];
    </script>
    
    <div id="fr-shortcode-form" style="display:none;">
    	<div class="fr_scw_wrap">
            <p class="fr_req_src_f_wrap">
                <label><?php _e('Predefined subject', 'fr_ml') ?></label>
                
                <select name="fr_sc_subj" style="width: 100%;" autocomplete="off">
                    <option value="">(<?php _e('none', 'fr_ml') ?>)</option>
                    
					<?php
                    foreach($subjs as $box) {
                        echo '<option value="'.$box->term_id.'">'.$box->name.'</option>';  
                    }
                    ?>
                </select>
            </p>
            <p class="fr_scw_sub_subj_wrap" style="display: none;">
                <label><?php _e('Predefined child subject', 'fr_ml') ?></label>
                <span class="fr_scw_sub_subj_dd"></span>
                
                <?php echo fr_sub_subjs_json('tinymce', $subjs) ?>
            </p>
            
            <p class="fr_req_src_f_wrap">
                <label><?php _e('Excluded subjects', 'fr_ml') ?></label>
                
                <select name="fr_sc_excl_subj" autocomplete="off" multiple>
					<?php
                    foreach(fr_sub_subsubjs_for_builders(true) as $val => $name) {
                        echo '<option value="'.$val.'">'.$name.'</option>';  
                    }
                    ?>
                </select>
            </p>
            <p class="fr_req_src_f_wrap">
            	<label><?php _e('Show FAQs only filling searchbar?', 'fr_ml') ?></label>
           		<input type="checkbox" name="fr_sc_req_src" value="1" class="ip-checkbox" autocomplete="off" />
            </p>
            <p>
                <input type="button" name="fr_sc_insert" class="button-primary" value="<?php _e('Insert', 'nb_ml') ?>" />
            </p>
        </div>	
    </div>    

    <script type="text/javascript">
	jQuery(document).ready(function($) {
        var child_subjs = fr_sub_subjs_list['tinymce'];
		
		// show sub-subj and req_src on subj change
		$(document).on('change', '.fr_magpop [name=fr_sc_subj]', function() {
			var val = $(this).val();
			
			
			// sub-subj
			if(!val || child_subjs[val].length === 0) {
				$('.fr_magpop .fr_scw_sub_subj_wrap').slideUp('fast');
				$('.fr_magpop .fr_scw_sub_subj_dd').empty();
				return true;	
			}
			
			var code = 
			'<select name="fr_sc_sub_subj" style="width: 100%">'+
				'<option value="">(<?php _e('none', 'fr_ml') ?>)</option>';

				$.each(child_subjs[val], function(id, data) {
					code += '<option value="'+ id +'">'+ data['name'] +'</option>';
				});
				
			$('.fr_magpop .fr_scw_sub_subj_dd').html( code +'</select>');
			$('.fr_magpop  .fr_scw_sub_subj_wrap').slideDown('fast');
		});
    });
	</script>
    <?php
}
add_action('admin_footer', 'fr_editor_btn_content');
